c utilities for phase/ampl:   phaseamp, phiwrap, phasedis, vectav,
c			      miniflip, flipper
c
c	history after jul '90:
c	30jul90  pjt   changed all " to '' (VMS doesn't like ")
c	22oct90  pjt   various changes to flipper
c	18nov90  pjt   made it faster!
c	20jan91  pjt   fixed timeaver bug in vectav()
c	30nov91  pjt   doc in vectav()
c	 2dec91  pjt   dealt with new (V6.4) calbflux dimension
c
c*PhaseAmp -- convert to phase/amplitude
c:calibration,phases
c&pjt
c+
        SUBROUTINE phaseamp( nbase, basediff, mark )
c
        INTEGER nbase, basediff(2, *)
        LOGICAL mark
c
c	PhaseAmp converts the Rdata() from Real-Imag to Amp-Phase
c	and also returns a list of 2pi wraps needed for closure
c NOTE:
c	It's use is now OBSOLETE since the new flipper(). A bug('w',
c	is called when phaseamp is used!
c
c  Inputs:
c	nbase    -- number of baselines used in basediff array
c	mark     -- whether to also mark unclosed data as bad in 'rflags'
c
c  Outputs:
c	basediff -- list of 2pi wraps needed for closure
c
c--
c >>> ../../src/inc/caldefs.h
c=======================================================================
c [caldefs.h]
c General include file that every calibration routine needs. It does not
c define (space for) data, but defines the constants that should be used
c in defining array-sizes.
c	18-nov-90 	added PI and TWOPI			PJT
c	 6-jul-91	V6.3 new MAXANTHC and MAXBASHC          pjt
c	26-sep-91       increased MAXUVPNT and MAXBREAK
c	 2-dec-91	V6.4 changed calbflux's dimensionality	PJT
c	19-apr-93	MAXSLOT from 20 to 36 for screwed mode-4  PJT
c			added MAXWIN from 8 (hardcoded) to 16
c	15-apr-94	MAXWIN is now in maxdim.h		PJT/mchw
c       19-dec-95       increase MAXANTHC from 6 to 9 !!!       pjt
c        9-Feb-99       increase MAXANTHC from 9 to 10 !       mchw
c       25-Apr-06       Increase MAXANTHC from 10 to 15 for CARMA ! mh
c=======================================================================
c >>> ../../src/inc/maxdim.h
c src/inc/cfg_maxdim.h.  Generated from maxdim.h.in by configure.
c TELESCOPE=carma
c=======================================================================
        CHARACTER*(*) MIRTEL
        PARAMETER(MIRTEL='carma')
        INTEGER   MAXBUF
        PARAMETER(MAXBUF=10000000)
c
        INTEGER   MAXDIM, MAXDIM2
        PARAMETER(MAXDIM=65536,MAXDIM2=8192)
c
        INTEGER   MAXANT,MAXANT2
        PARAMETER(MAXANT=64,MAXANT2=28)
c		maximum number of baselines
        INTEGER   MAXBASE
        PARAMETER(MAXBASE=1058)
        INTEGER   MAXBASE2
        PARAMETER(MAXBASE2=1058)
c
        INTEGER   MAXCHAN
        PARAMETER(MAXCHAN=8192)
c
        INTEGER   MAXWIN
        PARAMETER(MAXWIN=32)
c
        INTEGER   MAXWIDE
        PARAMETER(MAXWIDE=32)
c
        INTEGER   MAXFBIN
        PARAMETER(MAXFBIN=32)
c=======================================================================
c
c <<< ../../src/inc/maxdim.h
c=======================================================================
c >>> ../../src/inc/size.h
c=======================================================================
c	[size.h]
c
c  Include file used by calibration software
c
c  UL, RI, ULRI -- parameters which stand for LSB/USB and REAL/IMAG stuff
c
        integer UL, RI, ULRI
        parameter( UL = 2 )
        parameter( RI = 2 )
        parameter( ULRI = 4 )
c
c  SIZE -- lengths of reals/integers in number of bytes (IEEE/2s compl)
c
        integer SIZE
        parameter( SIZE = 4 )
c=======================================================================
c
c <<< ../../src/inc/size.h
c=======================================================================
c
c  SVERSION -- current version of cal format (consistency checks)
c              Version number is 10*MAJOR+MINOR
c              Datasets with a MAJOR difference, cannot be read
c              anymore, MINOR differences are normally compatible
c
      INTEGER SVERSION
      PARAMETER ( SVERSION = 64)
c
c MAXANTHC -- special Hat Creek MAXANT, to keep it small for us....
c MAXBASHC -- derived from MAXANTHC = max. number of baselines
c
c Now changed the number from Hat-Creek (10) to Cedar-Flat (15)
c although the name is the same.
c
      INTEGER MAXANTHC, MAXBASHC
      PARAMETER (MAXANTHC=15, MAXBASHC=((MAXANTHC*(MAXANTHC-1))/2))
c
c MAXUVPNT -- maximum number of UV points in time per track
c
      INTEGER   MAXUVPNT
      PARAMETER(MAXUVPNT=2000)
c
c  MAXSRC -- maximum number of sources in multi-source databases
c
      INTEGER MAXSRC
      PARAMETER( MAXSRC = 32 )
c
c  MAXBREAK -- maximum number of breakpoints on an interval
c
      INTEGER MAXBREAK
      PARAMETER( MAXBREAK = 10 )
c
c  MAXPOLY -- maximum number of polynomials on an interval
c             is normally one more than number of breakpoints, right?
c
      INTEGER MAXPOLY
      PARAMETER( MAXPOLY = MAXBREAK+1 )
c
c  MAXSLOT -- maximum number of polynomial slots
c             Allows for simultaneous presence of gcal & pcal format
c             The first 4 for gcal, last 16 for pcal
c             CALIB makes use of slot 5 and 6 for phase diff&mean
      INTEGER MAXSLOT
c      PARAMETER( MAXSLOT = 20 )
      PARAMETER( MAXSLOT = 36 )
c
c  MAXORDER -- highest allowed polynomial order
c             Don't set too high, inversions are already needed in
c             double precision this way.
      INTEGER MAXORDER
      PARAMETER( MAXORDER = 5 )
c
c  MAXWIN -- maximum number of windows - normally equals MAXSPECT = 8
c	     but temporarely increased to 16 to deal with mode=4
c	     problems.
c     INTEGER MAXWIN
c     PARAMETER ( MAXWIN = 16 )
c
c=======================================================================
c
c <<< ../../src/inc/caldefs.h
c >>> ../../src/inc/calsubs.h
c=======================================================================
c	[calsubs.h]
c
c	Last update:    22-may-90	deleted pmode	PJT
c			18-dec-90	played with  /calmode/ [Arie/Peter]
c			 7-jul-91       new MAXBASHC parameter
c			11-dec-91	documentation formalized in doc format
c
c*calsubs_h -- header file for calibration
c:calibration, include
c&pjt
c+
c
c  time0 -- Julian time offset for all time measurements
        DOUBLE PRECISION time0
c
c  base(nbl) -- the baseline number and order
        INTEGER nbl, base(MAXBASHC)
c
c  version -- the read version of cal format
        INTEGER version
c
c  calsubs -- THE common block
        COMMON /calsubs/ time0, nbl, base, version
c
c
c  kludge before upgrading to the next CAL-SVERSION
        INTEGER scalmode
c
c	0:	(old system) fitting is done in K
c	1:	fitting is done in data space (K/Jy), i.e. the same is above
c      -1:	fitting is done in gain space (Jy/K)
c
c   For now, scalmode is set in calfit and calflag and such.
c   CAopen should get an extra stamp for this, see calio.h
c
        COMMON /calscal/scalmode
c--
c   Mode of phase/amp calibration in calflag/calib/...
c   [may be used in Arie's calib.for - but is internal for now]
c   nmode=1   amp
c	  2   phase
c         3   diff
c
c	INTEGER nmode
c	COMMON /calmode/nmode
c=======================================================================
c
c <<< ../../src/inc/calsubs.h
c >>> ../../src/inc/caldata.h
c=======================================================================
c       [caldata.h]
c       Header file for calibration data
c
c       Last update:    14-mar-90       added Sflag     PJT
c                       20-mar-90       srcindex now srcindex(MAXPNT)   PJT
c                        7-may-90       rdata(ULRI,MAXBASHC,MAXUVPNT)   PJT
c                        4-sep-90       baseline based calib stuff      PJT
c                       18-nov-90       more descriptive comments       PJT
c                       18-dec-90       played with rdata()             PJT
c                        7-jul-91       MAXBASE -> BAXMASHC             PJT
c                        2-dec-91       make fluxes time dependant, not
c                                       source dependant; =V6.4 fmt     PJT
c                       11-dec-91       documentation formalized in doc format
c*caldata_h -- header file for calibration data
c:calibration, include
c&pjt
c+
c   The calibration format on disk is split out in memory over several
c   common blocks, each of them described in a separate include file.
c
c
c <general header> (see also calsubs.h)
c       double time0            time to which all times are offset (JD)
c       int    nbl              number of baselines
c       int    base(nbl)        nbl baselines (notation: A1*256+A2)
c       int    version          version of the calibration format
c
c <data> (this caldata.h include file)
c   rtime
c       float  rtime(rcount)             offset times to time0
c   rdata
c       float  rdata(ULRI,nbl,rcount)    correllation data
c   rflag
c       int    rflag(UL,nbl,rcount)      flagged bad? (0=false, 1=true)
c   sindex
c       int    sindex(rcount)            source index number
c   sname
c       char*16 sname(scount)             list of sources
c
c
c
c  Rxxxx -- the actual calibration data
c
      INTEGER   rcount
      REAL      rtime(MAXUVPNT)
      REAL      rdata(ULRI, MAXBASHC, MAXUVPNT)
      INTEGER   rflag(UL, MAXBASHC, MAXUVPNT)
c
c  Sxxxx -- index for multiple source calibration format
c           (plstuff was added later and is not quite needed??)
c
      INTEGER   scount
      CHARACTER sname(MAXSRC)*16
      INTEGER   sindex(MAXUVPNT), sflag(MAXUVPNT)
      REAL      plstuff(4,MAXSRC)
c
c  Bxxxx - list of break points
c
      REAL      btime(MAXBREAK, 2, MAXBASHC)
      INTEGER   bcount(2, MAXBASHC)
c
c  Xxxxx - odds and ends, should not really have to exist
c          are merely there for planets
c
      REAL      volts(MAXUVPNT)
c
c  baseline based calibrator fluxes, per time
c
      REAL      calbflux(MAXBASHC,MAXUVPNT)
c
c
c  the common blocks with all the data
c
      COMMON /caldatr/ rcount, scount, rtime, rdata, rflag,
     *                 sindex, btime, bcount, sflag, plstuff,volts
      COMMON /caldatc/ sname
      COMMON /caldatp/ calbflux
c--
c=======================================================================
c
c <<< ../../src/inc/caldata.h
c >>> ../../src/inc/mirconst.h
c=======================================================================
c - mirconst.h  Include file for various fundamental physical constants.
c
c  History:
c    jm  18dec90  Original code.  Constants taken from the paper
c                 "The Fundamental Physical Constants" by E. Richard
c                 Cohen and Barry N. Taylor (PHYICS TODAY, August 1989).
c   pjt  13aug08  Aligned with ATNF
c   pjt  14nov08  updated from latest NIST values
c                 http://physics.nist.gov/cuu/Constants/index.html
c
c $Id: mirconst.h,v 1.3 2008/11/15 04:22:29 pteuben Exp $
c ----------------------------------------------------------------------
c  Pi.
      double precision DPI, DPI_2, DPI_4, DTWOPI
      parameter (DPI = 3.14159265358979323846D0)
      parameter (DTWOPI = DPI * 2D0)
      parameter (DPI_2  = DPI / 2D0)
      parameter (DPI_4  = DPI / 4D0)
c
      real PI, PI_2, PI_4, TWOPI
      parameter (PI    = DPI)
      parameter (TWOPI = DTWOPI)
      parameter (PI_2  = DPI_2)
      parameter (PI_4  = DPI_4)
c ----------------------------------------------------------------------
c  Angular conversion factors.
      double precision DAS2R, DD2R, DR2AS, DR2D
      parameter (DD2R  =  DPI / 180D0)
      parameter (DR2D  =  1D0 / DD2R)
      parameter (DAS2R = DD2R / 3600D0)
      parameter (DR2AS =  1D0 / DAS2R)
c
      real AS2R, D2R, R2AS, R2D
      parameter (D2R   = DD2R)
      parameter (R2D   = DR2D)
      parameter (AS2R  = DAS2R)
      parameter (R2AS  = DR2AS)
c ----------------------------------------------------------------------
c  Speed of light (meter/second).
      double precision DCMKS
      parameter (DCMKS = 299792458D0)
c
      real CMKS
      parameter (CMKS = DCMKS)
c ----------------------------------------------------------------------
c  Boltzmann constant (Joule/Kelvin).
      double precision DKMKS
      parameter (DKMKS = 1.3806504D-23)
c
      real KMKS
      parameter (KMKS = DKMKS)
c ----------------------------------------------------------------------
c  Planck constant (Joule-second).
      double precision DHMKS
      parameter (DHMKS = 6.62606896D-34)
c
      real HMKS
      parameter (HMKS = DHMKS)
c ----------------------------------------------------------------------
c  Planck constant divided by Boltzmann constant (Kelvin/GHz).
      double precision DHOVERK
      parameter (DHOVERK = 1D9 * DHMKS / DKMKS)
c
      real HOVERK
      parameter (HOVERK = DHOVERK)
c=======================================================================
c <<< ../../src/inc/mirconst.h
c
        INTEGER i, j, b, c, d
        INTEGER phiwrap
        REAL    rtemp, itemp, paverage
        REAL    average(MAXBASHC, 2), phase(MAXBASHC)
        INTEGER wrap(MAXBASHC)
c
c  This routine is what we call the old phase flipper - do not
c  use it anymore, since it has known deficiences.
c
        CALL bug('w','Old phase-flipper PHASEAMP has been called')
c
c  convert to phase-amplitude
c
        DO b = 1, nbl
          DO c = 1, Rcount
            DO j = 1, 3, 2
              rtemp = rdata(j  ,b,c)
              itemp = rdata(j+1,b,c)
              rdata(j  ,b,c) = sqrt( rtemp*rtemp + itemp*itemp )
              rdata(j+1,b,c) = atan2( itemp, rtemp )
            ENDDO
          ENDDO
        ENDDO
c
c  make the phase continuous, as best as possible
c
        DO  j = 2, 4, 2
          DO  b = 1, nbl
            Paverage = Rdata(j,b,1)
            DO i = 2, Rcount / 4
                Paverage = ( Paverage + Rdata(j,b,i) ) / 2
            ENDDO
            DO i = Rcount / 4 + 1, Rcount
                d = ( Rdata(j,b,i) - Paverage ) / PI
                Rdata(j,b,i) = Rdata(j,b,i) - ( d + mod(d,2) ) * PI
                Paverage = ( Paverage + Rdata(j,b,i) ) / 2
            ENDDO
            Paverage = Rdata(j,b,Rcount)
            DO i = Rcount - 1, 3 * (Rcount / 4), -1
                Paverage = ( Paverage + Rdata(j,b,i) ) / 2
            ENDDO
            DO i = 3 * (Rcount / 4) - 1, 1, -1
                d = ( Rdata(j,b,i) - Paverage ) / PI
                Rdata(j,b,i) = Rdata(j,b,i) - ( d + mod(d,2) ) * PI
                Paverage = ( Paverage + Rdata(j,b,i) ) / 2
            ENDDO
          ENDDO
        ENDDO
c
c  find the average phase
c
        DO j = 1, 2
          DO b = 1, nbl
            average(b,j) = 0.0
            DO i = 1, Rcount
                average(b,j) = average(b,j) + Rdata(2*j,b,i)
            ENDDO
            average(b,j) = average(b,j) / Rcount
          ENDDO
        ENDDO
c
c  make the average phase near zero
c
        DO  j = 1, 2
          DO  b = 1, nbl
            d = phiwrap( average(b,j) )
            IF( d .ne. 0 ) THEN
                average(b,j) = average(b,j) - d * TWOPI
                DO i = 1, rcount
                    Rdata(2*j,b,i) = Rdata(2*j,b,i) - d * TWOPI
                ENDDO
            ENDIF
          ENDDO
        ENDDO
c
c  find consistent antenna phases
c
        DO j = 1, 2
            DO b = 1, nbl
                wrap(b) = 0
                phase(b) = average(b,j)
            ENDDO
            call phasedis( phase, wrap )
            DO  b = 1, nbl
                basediff(j,b) = wrap(b)
            ENDDO
        ENDDO
c
        DO  i = 1, Rcount
          DO  j = 1, 2
            DO b = 1, nbl
                wrap(b) = basediff(j,b)
                phase(b) = Rdata(2*j,b,i)
            ENDDO
            CALL phasedis( phase, wrap )
            IF( mark ) then
                DO b = 1, nbl
                    if( wrap(b) .ne. 0 ) then
                        if( j .eq. 1 ) then
                            write(0,*) 'phase non-closure, LSB:', i
                        else
                            write(0,*) 'phase non-closure, USB:', i
                        endif
                        DO d = 1, nbl
                            Rflag(j,d,i) = 0
                        ENDDO
c
                    ENDIF
                ENDDO
            ENDIF
          ENDDO
        ENDDO
        END
c*PhiWrap -- returns the number of 2pi wraps
c:calibration,phases
c&pjt
c+
        INTEGER FUNCTION phiwrap(phase)
c
        REAL phase
c
c       function to return number of 2.PI wrap arounds
c
c   	Note: OBSOLETE, is only called by 'phaseamp'
c
c       inputs:
c           phase       -- angle to be checked
c--
c >>> ../../src/inc/caldefs.h
c=======================================================================
c [caldefs.h]
c General include file that every calibration routine needs. It does not
c define (space for) data, but defines the constants that should be used
c in defining array-sizes.
c	18-nov-90 	added PI and TWOPI			PJT
c	 6-jul-91	V6.3 new MAXANTHC and MAXBASHC          pjt
c	26-sep-91       increased MAXUVPNT and MAXBREAK
c	 2-dec-91	V6.4 changed calbflux's dimensionality	PJT
c	19-apr-93	MAXSLOT from 20 to 36 for screwed mode-4  PJT
c			added MAXWIN from 8 (hardcoded) to 16
c	15-apr-94	MAXWIN is now in maxdim.h		PJT/mchw
c       19-dec-95       increase MAXANTHC from 6 to 9 !!!       pjt
c        9-Feb-99       increase MAXANTHC from 9 to 10 !       mchw
c       25-Apr-06       Increase MAXANTHC from 10 to 15 for CARMA ! mh
c=======================================================================
c >>> ../../src/inc/maxdim.h
c src/inc/cfg_maxdim.h.  Generated from maxdim.h.in by configure.
c TELESCOPE=carma
c=======================================================================
        CHARACTER*(*) MIRTEL
        PARAMETER(MIRTEL='carma')
        INTEGER   MAXBUF
        PARAMETER(MAXBUF=10000000)
c
        INTEGER   MAXDIM, MAXDIM2
        PARAMETER(MAXDIM=65536,MAXDIM2=8192)
c
        INTEGER   MAXANT,MAXANT2
        PARAMETER(MAXANT=64,MAXANT2=28)
c		maximum number of baselines
        INTEGER   MAXBASE
        PARAMETER(MAXBASE=1058)
        INTEGER   MAXBASE2
        PARAMETER(MAXBASE2=1058)
c
        INTEGER   MAXCHAN
        PARAMETER(MAXCHAN=8192)
c
        INTEGER   MAXWIN
        PARAMETER(MAXWIN=32)
c
        INTEGER   MAXWIDE
        PARAMETER(MAXWIDE=32)
c
        INTEGER   MAXFBIN
        PARAMETER(MAXFBIN=32)
c=======================================================================
c
c <<< ../../src/inc/maxdim.h
c=======================================================================
c >>> ../../src/inc/size.h
c=======================================================================
c	[size.h]
c
c  Include file used by calibration software
c
c  UL, RI, ULRI -- parameters which stand for LSB/USB and REAL/IMAG stuff
c
        integer UL, RI, ULRI
        parameter( UL = 2 )
        parameter( RI = 2 )
        parameter( ULRI = 4 )
c
c  SIZE -- lengths of reals/integers in number of bytes (IEEE/2s compl)
c
        integer SIZE
        parameter( SIZE = 4 )
c=======================================================================
c
c <<< ../../src/inc/size.h
c=======================================================================
c
c  SVERSION -- current version of cal format (consistency checks)
c              Version number is 10*MAJOR+MINOR
c              Datasets with a MAJOR difference, cannot be read
c              anymore, MINOR differences are normally compatible
c
      INTEGER SVERSION
      PARAMETER ( SVERSION = 64)
c
c MAXANTHC -- special Hat Creek MAXANT, to keep it small for us....
c MAXBASHC -- derived from MAXANTHC = max. number of baselines
c
c Now changed the number from Hat-Creek (10) to Cedar-Flat (15)
c although the name is the same.
c
      INTEGER MAXANTHC, MAXBASHC
      PARAMETER (MAXANTHC=15, MAXBASHC=((MAXANTHC*(MAXANTHC-1))/2))
c
c MAXUVPNT -- maximum number of UV points in time per track
c
      INTEGER   MAXUVPNT
      PARAMETER(MAXUVPNT=2000)
c
c  MAXSRC -- maximum number of sources in multi-source databases
c
      INTEGER MAXSRC
      PARAMETER( MAXSRC = 32 )
c
c  MAXBREAK -- maximum number of breakpoints on an interval
c
      INTEGER MAXBREAK
      PARAMETER( MAXBREAK = 10 )
c
c  MAXPOLY -- maximum number of polynomials on an interval
c             is normally one more than number of breakpoints, right?
c
      INTEGER MAXPOLY
      PARAMETER( MAXPOLY = MAXBREAK+1 )
c
c  MAXSLOT -- maximum number of polynomial slots
c             Allows for simultaneous presence of gcal & pcal format
c             The first 4 for gcal, last 16 for pcal
c             CALIB makes use of slot 5 and 6 for phase diff&mean
      INTEGER MAXSLOT
c      PARAMETER( MAXSLOT = 20 )
      PARAMETER( MAXSLOT = 36 )
c
c  MAXORDER -- highest allowed polynomial order
c             Don't set too high, inversions are already needed in
c             double precision this way.
      INTEGER MAXORDER
      PARAMETER( MAXORDER = 5 )
c
c  MAXWIN -- maximum number of windows - normally equals MAXSPECT = 8
c	     but temporarely increased to 16 to deal with mode=4
c	     problems.
c     INTEGER MAXWIN
c     PARAMETER ( MAXWIN = 16 )
c
c=======================================================================
c
c <<< ../../src/inc/caldefs.h
c >>> ../../src/inc/mirconst.h
c=======================================================================
c - mirconst.h  Include file for various fundamental physical constants.
c
c  History:
c    jm  18dec90  Original code.  Constants taken from the paper
c                 "The Fundamental Physical Constants" by E. Richard
c                 Cohen and Barry N. Taylor (PHYICS TODAY, August 1989).
c   pjt  13aug08  Aligned with ATNF
c   pjt  14nov08  updated from latest NIST values
c                 http://physics.nist.gov/cuu/Constants/index.html
c
c $Id: mirconst.h,v 1.3 2008/11/15 04:22:29 pteuben Exp $
c ----------------------------------------------------------------------
c  Pi.
      double precision DPI, DPI_2, DPI_4, DTWOPI
      parameter (DPI = 3.14159265358979323846D0)
      parameter (DTWOPI = DPI * 2D0)
      parameter (DPI_2  = DPI / 2D0)
      parameter (DPI_4  = DPI / 4D0)
c
      real PI, PI_2, PI_4, TWOPI
      parameter (PI    = DPI)
      parameter (TWOPI = DTWOPI)
      parameter (PI_2  = DPI_2)
      parameter (PI_4  = DPI_4)
c ----------------------------------------------------------------------
c  Angular conversion factors.
      double precision DAS2R, DD2R, DR2AS, DR2D
      parameter (DD2R  =  DPI / 180D0)
      parameter (DR2D  =  1D0 / DD2R)
      parameter (DAS2R = DD2R / 3600D0)
      parameter (DR2AS =  1D0 / DAS2R)
c
      real AS2R, D2R, R2AS, R2D
      parameter (D2R   = DD2R)
      parameter (R2D   = DR2D)
      parameter (AS2R  = DAS2R)
      parameter (R2AS  = DR2AS)
c ----------------------------------------------------------------------
c  Speed of light (meter/second).
      double precision DCMKS
      parameter (DCMKS = 299792458D0)
c
      real CMKS
      parameter (CMKS = DCMKS)
c ----------------------------------------------------------------------
c  Boltzmann constant (Joule/Kelvin).
      double precision DKMKS
      parameter (DKMKS = 1.3806504D-23)
c
      real KMKS
      parameter (KMKS = DKMKS)
c ----------------------------------------------------------------------
c  Planck constant (Joule-second).
      double precision DHMKS
      parameter (DHMKS = 6.62606896D-34)
c
      real HMKS
      parameter (HMKS = DHMKS)
c ----------------------------------------------------------------------
c  Planck constant divided by Boltzmann constant (Kelvin/GHz).
      double precision DHOVERK
      parameter (DHOVERK = 1D9 * DHMKS / DKMKS)
c
      real HOVERK
      parameter (HOVERK = DHOVERK)
c=======================================================================
c <<< ../../src/inc/mirconst.h
c
        phiwrap = phase / TWOPI
        IF( (phase - phiwrap * TWOPI) .GT.  PI ) phiwrap = phiwrap + 1
        IF( (phase - phiwrap * TWOPI) .LT. -PI ) phiwrap = phiwrap - 1
c
c  phiwrap = phase / PI
c  phiwrap = 2 * ( phiwrap + mod(phiwrap,2) )
c
        END
c*phasedis -- find consistent antenna phases
c:calibration,phases
c&pjt
c+
        SUBROUTINE phasedis( phase, wraps )
c
        REAL    phase(*)
        INTEGER wraps(*)
c
c  Note: Not the most robust algorithm ever invented -- perhaps looping
c        through multiple times would help
c	 This subroutine is OBSOLETE since it is used with 'phaseamp'
c
c  Inputs:
c	phase -- list of phases for each baseline
c
c  Outputs:
c	wraps -- list of 2pi wraps for each baseline
c
c--
c >>> ../../src/inc/caldefs.h
c=======================================================================
c [caldefs.h]
c General include file that every calibration routine needs. It does not
c define (space for) data, but defines the constants that should be used
c in defining array-sizes.
c	18-nov-90 	added PI and TWOPI			PJT
c	 6-jul-91	V6.3 new MAXANTHC and MAXBASHC          pjt
c	26-sep-91       increased MAXUVPNT and MAXBREAK
c	 2-dec-91	V6.4 changed calbflux's dimensionality	PJT
c	19-apr-93	MAXSLOT from 20 to 36 for screwed mode-4  PJT
c			added MAXWIN from 8 (hardcoded) to 16
c	15-apr-94	MAXWIN is now in maxdim.h		PJT/mchw
c       19-dec-95       increase MAXANTHC from 6 to 9 !!!       pjt
c        9-Feb-99       increase MAXANTHC from 9 to 10 !       mchw
c       25-Apr-06       Increase MAXANTHC from 10 to 15 for CARMA ! mh
c=======================================================================
c >>> ../../src/inc/maxdim.h
c src/inc/cfg_maxdim.h.  Generated from maxdim.h.in by configure.
c TELESCOPE=carma
c=======================================================================
        CHARACTER*(*) MIRTEL
        PARAMETER(MIRTEL='carma')
        INTEGER   MAXBUF
        PARAMETER(MAXBUF=10000000)
c
        INTEGER   MAXDIM, MAXDIM2
        PARAMETER(MAXDIM=65536,MAXDIM2=8192)
c
        INTEGER   MAXANT,MAXANT2
        PARAMETER(MAXANT=64,MAXANT2=28)
c		maximum number of baselines
        INTEGER   MAXBASE
        PARAMETER(MAXBASE=1058)
        INTEGER   MAXBASE2
        PARAMETER(MAXBASE2=1058)
c
        INTEGER   MAXCHAN
        PARAMETER(MAXCHAN=8192)
c
        INTEGER   MAXWIN
        PARAMETER(MAXWIN=32)
c
        INTEGER   MAXWIDE
        PARAMETER(MAXWIDE=32)
c
        INTEGER   MAXFBIN
        PARAMETER(MAXFBIN=32)
c=======================================================================
c
c <<< ../../src/inc/maxdim.h
c=======================================================================
c >>> ../../src/inc/size.h
c=======================================================================
c	[size.h]
c
c  Include file used by calibration software
c
c  UL, RI, ULRI -- parameters which stand for LSB/USB and REAL/IMAG stuff
c
        integer UL, RI, ULRI
        parameter( UL = 2 )
        parameter( RI = 2 )
        parameter( ULRI = 4 )
c
c  SIZE -- lengths of reals/integers in number of bytes (IEEE/2s compl)
c
        integer SIZE
        parameter( SIZE = 4 )
c=======================================================================
c
c <<< ../../src/inc/size.h
c=======================================================================
c
c  SVERSION -- current version of cal format (consistency checks)
c              Version number is 10*MAJOR+MINOR
c              Datasets with a MAJOR difference, cannot be read
c              anymore, MINOR differences are normally compatible
c
      INTEGER SVERSION
      PARAMETER ( SVERSION = 64)
c
c MAXANTHC -- special Hat Creek MAXANT, to keep it small for us....
c MAXBASHC -- derived from MAXANTHC = max. number of baselines
c
c Now changed the number from Hat-Creek (10) to Cedar-Flat (15)
c although the name is the same.
c
      INTEGER MAXANTHC, MAXBASHC
      PARAMETER (MAXANTHC=15, MAXBASHC=((MAXANTHC*(MAXANTHC-1))/2))
c
c MAXUVPNT -- maximum number of UV points in time per track
c
      INTEGER   MAXUVPNT
      PARAMETER(MAXUVPNT=2000)
c
c  MAXSRC -- maximum number of sources in multi-source databases
c
      INTEGER MAXSRC
      PARAMETER( MAXSRC = 32 )
c
c  MAXBREAK -- maximum number of breakpoints on an interval
c
      INTEGER MAXBREAK
      PARAMETER( MAXBREAK = 10 )
c
c  MAXPOLY -- maximum number of polynomials on an interval
c             is normally one more than number of breakpoints, right?
c
      INTEGER MAXPOLY
      PARAMETER( MAXPOLY = MAXBREAK+1 )
c
c  MAXSLOT -- maximum number of polynomial slots
c             Allows for simultaneous presence of gcal & pcal format
c             The first 4 for gcal, last 16 for pcal
c             CALIB makes use of slot 5 and 6 for phase diff&mean
      INTEGER MAXSLOT
c      PARAMETER( MAXSLOT = 20 )
      PARAMETER( MAXSLOT = 36 )
c
c  MAXORDER -- highest allowed polynomial order
c             Don't set too high, inversions are already needed in
c             double precision this way.
      INTEGER MAXORDER
      PARAMETER( MAXORDER = 5 )
c
c  MAXWIN -- maximum number of windows - normally equals MAXSPECT = 8
c	     but temporarely increased to 16 to deal with mode=4
c	     problems.
c     INTEGER MAXWIN
c     PARAMETER ( MAXWIN = 16 )
c
c=======================================================================
c
c <<< ../../src/inc/caldefs.h
c >>> ../../src/inc/calsubs.h
c=======================================================================
c	[calsubs.h]
c
c	Last update:    22-may-90	deleted pmode	PJT
c			18-dec-90	played with  /calmode/ [Arie/Peter]
c			 7-jul-91       new MAXBASHC parameter
c			11-dec-91	documentation formalized in doc format
c
c*calsubs_h -- header file for calibration
c:calibration, include
c&pjt
c+
c
c  time0 -- Julian time offset for all time measurements
        DOUBLE PRECISION time0
c
c  base(nbl) -- the baseline number and order
        INTEGER nbl, base(MAXBASHC)
c
c  version -- the read version of cal format
        INTEGER version
c
c  calsubs -- THE common block
        COMMON /calsubs/ time0, nbl, base, version
c
c
c  kludge before upgrading to the next CAL-SVERSION
        INTEGER scalmode
c
c	0:	(old system) fitting is done in K
c	1:	fitting is done in data space (K/Jy), i.e. the same is above
c      -1:	fitting is done in gain space (Jy/K)
c
c   For now, scalmode is set in calfit and calflag and such.
c   CAopen should get an extra stamp for this, see calio.h
c
        COMMON /calscal/scalmode
c--
c   Mode of phase/amp calibration in calflag/calib/...
c   [may be used in Arie's calib.for - but is internal for now]
c   nmode=1   amp
c	  2   phase
c         3   diff
c
c	INTEGER nmode
c	COMMON /calmode/nmode
c=======================================================================
c
c <<< ../../src/inc/calsubs.h
c >>> ../../src/inc/mirconst.h
c=======================================================================
c - mirconst.h  Include file for various fundamental physical constants.
c
c  History:
c    jm  18dec90  Original code.  Constants taken from the paper
c                 "The Fundamental Physical Constants" by E. Richard
c                 Cohen and Barry N. Taylor (PHYICS TODAY, August 1989).
c   pjt  13aug08  Aligned with ATNF
c   pjt  14nov08  updated from latest NIST values
c                 http://physics.nist.gov/cuu/Constants/index.html
c
c $Id: mirconst.h,v 1.3 2008/11/15 04:22:29 pteuben Exp $
c ----------------------------------------------------------------------
c  Pi.
      double precision DPI, DPI_2, DPI_4, DTWOPI
      parameter (DPI = 3.14159265358979323846D0)
      parameter (DTWOPI = DPI * 2D0)
      parameter (DPI_2  = DPI / 2D0)
      parameter (DPI_4  = DPI / 4D0)
c
      real PI, PI_2, PI_4, TWOPI
      parameter (PI    = DPI)
      parameter (TWOPI = DTWOPI)
      parameter (PI_2  = DPI_2)
      parameter (PI_4  = DPI_4)
c ----------------------------------------------------------------------
c  Angular conversion factors.
      double precision DAS2R, DD2R, DR2AS, DR2D
      parameter (DD2R  =  DPI / 180D0)
      parameter (DR2D  =  1D0 / DD2R)
      parameter (DAS2R = DD2R / 3600D0)
      parameter (DR2AS =  1D0 / DAS2R)
c
      real AS2R, D2R, R2AS, R2D
      parameter (D2R   = DD2R)
      parameter (R2D   = DR2D)
      parameter (AS2R  = DAS2R)
      parameter (R2AS  = DR2AS)
c ----------------------------------------------------------------------
c  Speed of light (meter/second).
      double precision DCMKS
      parameter (DCMKS = 299792458D0)
c
      real CMKS
      parameter (CMKS = DCMKS)
c ----------------------------------------------------------------------
c  Boltzmann constant (Joule/Kelvin).
      double precision DKMKS
      parameter (DKMKS = 1.3806504D-23)
c
      real KMKS
      parameter (KMKS = DKMKS)
c ----------------------------------------------------------------------
c  Planck constant (Joule-second).
      double precision DHMKS
      parameter (DHMKS = 6.62606896D-34)
c
      real HMKS
      parameter (HMKS = DHMKS)
c ----------------------------------------------------------------------
c  Planck constant divided by Boltzmann constant (Kelvin/GHz).
      double precision DHOVERK
      parameter (DHOVERK = 1D9 * DHMKS / DKMKS)
c
      real HOVERK
      parameter (HOVERK = DHOVERK)
c=======================================================================
c <<< ../../src/inc/mirconst.h
c
        INTEGER b, phiwrap
        INTEGER ant1, ant2, Nant(MAXANTHC)
        REAL    antphase(MAXANTHC)
        REAL    curdiff, newdiff, zero
c
        DO ant1 = 1, MAXANTHC
            nant(ant1) = 0
        ENDDO
c
        DO b = 1, nbl
            ant1 = base(b) / 256
            ant2 = mod( base(b), 256 )
            newdiff = phase(b) + wraps(b) * TWOPI
            IF( (Nant(ant1) .eq. 0) .and. (Nant(ant2) .eq. 0) ) THEN
                antphase(ant1) =  newdiff / 2
                antphase(ant2) = -newdiff / 2
            ELSEIF( Nant(ant1) .eq. 0 ) THEN
                antphase(ant1) = antphase(ant2) + newdiff
            ELSEIF( Nant(ant2) .eq. 0 ) THEN
                antphase(ant2) = antphase(ant1) - newdiff
            ELSE
                curdiff = antphase(ant1) - antphase(ant2)
                wraps(b) = phiwrap( curdiff - newdiff )
                newdiff = newdiff + wraps(b) * TWOPI
                zero = ( antphase(ant1) + antphase(ant2) ) / 2
                antphase(ant1) = zero + ( Nant(ant1) * curdiff +
     *              newdiff ) / ( 2 * Nant(ant1) + 2 )
                antphase(ant2) = zero - ( Nant(ant2) * curdiff -
     *              newdiff ) / ( 2 * Nant(ant2) + 2 )
            ENDIF
            nant(ant1) = nant(ant1) + 1
            nant(ant2) = nant(ant2) + 1
        ENDDO
c
        END
c-----------------------------------------------------------------------
c*vectav -- vector averaging with lookup index table
c:calibration, vector-average
c&pjt
c+
      SUBROUTINE vectav (b,p,count,avidx,clump,nclump,x,y,dtaver,tmax)
c
      INTEGER avidx(*), clump(*), b, p, count, nclump
      REAL    x(*), y(*), dtaver,tmax
c
c  Vector average the wide band calibration data in rdata(). For a
c  given set (baseline,slot)=(b,p) a vector average with time
c  resolution 'dtaver' is done. Data are assumed to be timesorted
c  through the avidx() index array.
c  Note that the data in /CALDATA/ must be in unscaled K, after the
c  vector averaging is done, rescaling is done to get requested
c  K/Jy (see AMPSCAL how this can be done)
c
c  Input:
c     b        --  baseline index (1..nbl)
c     p        --  slot for phase/amplitude (1..4)
c     count    --  length of index array (lookup table in Rtime())
c     avidx    --  index array: Rtime(avidx(i)) are used
c     dtaver   --  max timestep in clump formation
c     tmax     --  max time to integrate for in clump formation
c  Output:
c     nclump   --  length of filled in data in array (x,y)
c     x        --  array of averaged times (x(j), j=1..nclump)
c     y        --  array of vector averaged phase or amplitude (see p)
c     clump    --  lookup table of original data into clumps:
c                   Data-element avidx(i) was used in clump(j)
c                   (i=1..count)  (j=1..nclump)
c
c--
c	Written:   xx-jul-90  PJT
c       Updates:   22-oct-90  pjt  added defensive 'bad' count
c                  20-jan-91  pjt  fixed bug in amp. scaling
c	           30-nov-91  pjt  never stopped aver when source changes
c
c >>> ../../src/inc/caldefs.h
c=======================================================================
c [caldefs.h]
c General include file that every calibration routine needs. It does not
c define (space for) data, but defines the constants that should be used
c in defining array-sizes.
c	18-nov-90 	added PI and TWOPI			PJT
c	 6-jul-91	V6.3 new MAXANTHC and MAXBASHC          pjt
c	26-sep-91       increased MAXUVPNT and MAXBREAK
c	 2-dec-91	V6.4 changed calbflux's dimensionality	PJT
c	19-apr-93	MAXSLOT from 20 to 36 for screwed mode-4  PJT
c			added MAXWIN from 8 (hardcoded) to 16
c	15-apr-94	MAXWIN is now in maxdim.h		PJT/mchw
c       19-dec-95       increase MAXANTHC from 6 to 9 !!!       pjt
c        9-Feb-99       increase MAXANTHC from 9 to 10 !       mchw
c       25-Apr-06       Increase MAXANTHC from 10 to 15 for CARMA ! mh
c=======================================================================
c >>> ../../src/inc/maxdim.h
c src/inc/cfg_maxdim.h.  Generated from maxdim.h.in by configure.
c TELESCOPE=carma
c=======================================================================
        CHARACTER*(*) MIRTEL
        PARAMETER(MIRTEL='carma')
        INTEGER   MAXBUF
        PARAMETER(MAXBUF=10000000)
c
        INTEGER   MAXDIM, MAXDIM2
        PARAMETER(MAXDIM=65536,MAXDIM2=8192)
c
        INTEGER   MAXANT,MAXANT2
        PARAMETER(MAXANT=64,MAXANT2=28)
c		maximum number of baselines
        INTEGER   MAXBASE
        PARAMETER(MAXBASE=1058)
        INTEGER   MAXBASE2
        PARAMETER(MAXBASE2=1058)
c
        INTEGER   MAXCHAN
        PARAMETER(MAXCHAN=8192)
c
        INTEGER   MAXWIN
        PARAMETER(MAXWIN=32)
c
        INTEGER   MAXWIDE
        PARAMETER(MAXWIDE=32)
c
        INTEGER   MAXFBIN
        PARAMETER(MAXFBIN=32)
c=======================================================================
c
c <<< ../../src/inc/maxdim.h
c=======================================================================
c >>> ../../src/inc/size.h
c=======================================================================
c	[size.h]
c
c  Include file used by calibration software
c
c  UL, RI, ULRI -- parameters which stand for LSB/USB and REAL/IMAG stuff
c
        integer UL, RI, ULRI
        parameter( UL = 2 )
        parameter( RI = 2 )
        parameter( ULRI = 4 )
c
c  SIZE -- lengths of reals/integers in number of bytes (IEEE/2s compl)
c
        integer SIZE
        parameter( SIZE = 4 )
c=======================================================================
c
c <<< ../../src/inc/size.h
c=======================================================================
c
c  SVERSION -- current version of cal format (consistency checks)
c              Version number is 10*MAJOR+MINOR
c              Datasets with a MAJOR difference, cannot be read
c              anymore, MINOR differences are normally compatible
c
      INTEGER SVERSION
      PARAMETER ( SVERSION = 64)
c
c MAXANTHC -- special Hat Creek MAXANT, to keep it small for us....
c MAXBASHC -- derived from MAXANTHC = max. number of baselines
c
c Now changed the number from Hat-Creek (10) to Cedar-Flat (15)
c although the name is the same.
c
      INTEGER MAXANTHC, MAXBASHC
      PARAMETER (MAXANTHC=15, MAXBASHC=((MAXANTHC*(MAXANTHC-1))/2))
c
c MAXUVPNT -- maximum number of UV points in time per track
c
      INTEGER   MAXUVPNT
      PARAMETER(MAXUVPNT=2000)
c
c  MAXSRC -- maximum number of sources in multi-source databases
c
      INTEGER MAXSRC
      PARAMETER( MAXSRC = 32 )
c
c  MAXBREAK -- maximum number of breakpoints on an interval
c
      INTEGER MAXBREAK
      PARAMETER( MAXBREAK = 10 )
c
c  MAXPOLY -- maximum number of polynomials on an interval
c             is normally one more than number of breakpoints, right?
c
      INTEGER MAXPOLY
      PARAMETER( MAXPOLY = MAXBREAK+1 )
c
c  MAXSLOT -- maximum number of polynomial slots
c             Allows for simultaneous presence of gcal & pcal format
c             The first 4 for gcal, last 16 for pcal
c             CALIB makes use of slot 5 and 6 for phase diff&mean
      INTEGER MAXSLOT
c      PARAMETER( MAXSLOT = 20 )
      PARAMETER( MAXSLOT = 36 )
c
c  MAXORDER -- highest allowed polynomial order
c             Don't set too high, inversions are already needed in
c             double precision this way.
      INTEGER MAXORDER
      PARAMETER( MAXORDER = 5 )
c
c  MAXWIN -- maximum number of windows - normally equals MAXSPECT = 8
c	     but temporarely increased to 16 to deal with mode=4
c	     problems.
c     INTEGER MAXWIN
c     PARAMETER ( MAXWIN = 16 )
c
c=======================================================================
c
c <<< ../../src/inc/caldefs.h
c >>> ../../src/inc/calsubs.h
c=======================================================================
c	[calsubs.h]
c
c	Last update:    22-may-90	deleted pmode	PJT
c			18-dec-90	played with  /calmode/ [Arie/Peter]
c			 7-jul-91       new MAXBASHC parameter
c			11-dec-91	documentation formalized in doc format
c
c*calsubs_h -- header file for calibration
c:calibration, include
c&pjt
c+
c
c  time0 -- Julian time offset for all time measurements
        DOUBLE PRECISION time0
c
c  base(nbl) -- the baseline number and order
        INTEGER nbl, base(MAXBASHC)
c
c  version -- the read version of cal format
        INTEGER version
c
c  calsubs -- THE common block
        COMMON /calsubs/ time0, nbl, base, version
c
c
c  kludge before upgrading to the next CAL-SVERSION
        INTEGER scalmode
c
c	0:	(old system) fitting is done in K
c	1:	fitting is done in data space (K/Jy), i.e. the same is above
c      -1:	fitting is done in gain space (Jy/K)
c
c   For now, scalmode is set in calfit and calflag and such.
c   CAopen should get an extra stamp for this, see calio.h
c
        COMMON /calscal/scalmode
c--
c   Mode of phase/amp calibration in calflag/calib/...
c   [may be used in Arie's calib.for - but is internal for now]
c   nmode=1   amp
c	  2   phase
c         3   diff
c
c	INTEGER nmode
c	COMMON /calmode/nmode
c=======================================================================
c
c <<< ../../src/inc/calsubs.h
c >>> ../../src/inc/caldata.h
c=======================================================================
c       [caldata.h]
c       Header file for calibration data
c
c       Last update:    14-mar-90       added Sflag     PJT
c                       20-mar-90       srcindex now srcindex(MAXPNT)   PJT
c                        7-may-90       rdata(ULRI,MAXBASHC,MAXUVPNT)   PJT
c                        4-sep-90       baseline based calib stuff      PJT
c                       18-nov-90       more descriptive comments       PJT
c                       18-dec-90       played with rdata()             PJT
c                        7-jul-91       MAXBASE -> BAXMASHC             PJT
c                        2-dec-91       make fluxes time dependant, not
c                                       source dependant; =V6.4 fmt     PJT
c                       11-dec-91       documentation formalized in doc format
c*caldata_h -- header file for calibration data
c:calibration, include
c&pjt
c+
c   The calibration format on disk is split out in memory over several
c   common blocks, each of them described in a separate include file.
c
c
c <general header> (see also calsubs.h)
c       double time0            time to which all times are offset (JD)
c       int    nbl              number of baselines
c       int    base(nbl)        nbl baselines (notation: A1*256+A2)
c       int    version          version of the calibration format
c
c <data> (this caldata.h include file)
c   rtime
c       float  rtime(rcount)             offset times to time0
c   rdata
c       float  rdata(ULRI,nbl,rcount)    correllation data
c   rflag
c       int    rflag(UL,nbl,rcount)      flagged bad? (0=false, 1=true)
c   sindex
c       int    sindex(rcount)            source index number
c   sname
c       char*16 sname(scount)             list of sources
c
c
c
c  Rxxxx -- the actual calibration data
c
      INTEGER   rcount
      REAL      rtime(MAXUVPNT)
      REAL      rdata(ULRI, MAXBASHC, MAXUVPNT)
      INTEGER   rflag(UL, MAXBASHC, MAXUVPNT)
c
c  Sxxxx -- index for multiple source calibration format
c           (plstuff was added later and is not quite needed??)
c
      INTEGER   scount
      CHARACTER sname(MAXSRC)*16
      INTEGER   sindex(MAXUVPNT), sflag(MAXUVPNT)
      REAL      plstuff(4,MAXSRC)
c
c  Bxxxx - list of break points
c
      REAL      btime(MAXBREAK, 2, MAXBASHC)
      INTEGER   bcount(2, MAXBASHC)
c
c  Xxxxx - odds and ends, should not really have to exist
c          are merely there for planets
c
      REAL      volts(MAXUVPNT)
c
c  baseline based calibrator fluxes, per time
c
      REAL      calbflux(MAXBASHC,MAXUVPNT)
c
c
c  the common blocks with all the data
c
      COMMON /caldatr/ rcount, scount, rtime, rdata, rflag,
     *                 sindex, btime, bcount, sflag, plstuff,volts
      COMMON /caldatc/ sname
      COMMON /caldatp/ calbflux
c--
c=======================================================================
c
c <<< ../../src/inc/caldata.h
c
      INTEGER   i, ic, p1, p2, nsum, bad, flips(MAXUVPNT), snow
      REAL      t0, t1, tsum, xsum, ysum, psum
      CHARACTER mesg*80
c
c  Check if there were any 'bad' index references
c
      bad = 0
      DO i=1,count
         IF (avidx(i).LE.0) bad=bad+1
      ENDDO
      IF(bad.GT.0) THEN
         WRITE(mesg,'(A,I5,I5)') 'VECTAV: bad avidx count,bad',
     *                          count,bad
        CALL bug('w',mesg)
      ENDIF
c
c *Since this version is buggy with respect to stuff outside +/-pi
c *when no time averaging done, it does it fast and good: nothing.
c *This code will not be needed anymore when submini() is ready
c *and working
c *
      IF (dtaver.LE.0.0) THEN
         DO i=1,count
           ic=avidx(i)
           clump(i) = ic
           x(i) = rtime(ic)
           y(i) = rdata(p,b,ic)
           IF(mod(p,2).EQ.1)
     *        CALL ampscal(y(i),calbflux(b,ic),scalmode)
         ENDDO
         nclump = count
         RETURN
      ENDIF
c *
c *End of later_to_be_removed_code?
c *
c
c     * slot pointers for phase (p2) and amplitude (p1)
      p1 = (p+1)/2
      p2 = 2*p1
      p1 = p2-1
c
c     * 'i' points to input array, 'nclump' counts output array (x,y)
c	avidx(i) will count up in time
      i = 1
      nclump = 0
      DO WHILE (i.LE.count)
         t0 = rtime(avidx(i))
         t1 = t0
         snow = sindex(avidx(i))
         nsum = 0
         tsum = 0.0
         xsum = 0.0
         ysum = 0.0
         psum = 0.0
         DOWHILE ( (i.LE.count)
     *             .AND.
     *             ( ( (rtime(avidx(i))-t0) .LT. tmax  .AND.
     *                 (rtime(avidx(i))-t1) .LT. dtaver
     *               )
     *               .OR.
     *               nsum.EQ.0
     *             )
     *             .AND.
     *             (sindex(avidx(i)).EQ.snow)
     *           )
c+debug
c	IF(p.EQ.3 .AND. b.EQ.2) THEN
c	   WRITE(*,*) 'added to clump: i, x, y', avidx(i),
c     *		rdata(p1,b,avidx(i))*cos(rdata(p2,b,avidx(i))),
c     *          rdata(p1,b,avidx(i))*sin(rdata(p2,b,avidx(i)))
c	ENDIF
c-debug
            nsum=nsum + 1
            tsum=tsum + rtime(avidx(i))
            xsum=xsum + rdata(p1,b,avidx(i))*cos(rdata(p2,b,avidx(i)))
            ysum=ysum + rdata(p1,b,avidx(i))*sin(rdata(p2,b,avidx(i)))
            psum=psum + rdata(p2,b,avidx(i))
            clump(i) = nclump+1
            t1 = rtime(avidx(i))
            snow = sindex(avidx(i))
            i = i+1
         ENDDO
         IF (nsum.GT.0) THEN
            nclump = nclump + 1
c+debug+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
c	IF(p.EQ.3 .AND. b.EQ.2) THEN
c      write(*,*) 'vectav debug: b,p,nclump,nsum: ',b,p,nclump,nsum
c	ENDIF
c-debug-----------------------------------------------------------------------
            x(nclump) = tsum/REAL(nsum)
            IF (MOD(p,2).EQ.0) THEN
c              * phase, but check if average (scalar) angle is near enough
               y(nclump) = ATAN2(ysum,xsum)
               psum = psum/REAL(nsum)
c              DOWHILE ( ABS(psum-y(nclump)) .GT. 3.1415)
c                  IF (psum-y(nclump) .GT. 3.1415) THEN
c                     y(nclump) = y(nclump) + 6.28318
c                  ELSE
c                     y(nclump) = y(nclump) - 6.28318
c                  ENDIF
c              ENDDO
            ELSE
c              * amplitude (really the scaling is somewhat off for planets)
c		 since the 'i-1' is used, and not some <i> of the scan
c		 this is too much for me right now being at Hat Creek (PJT)
c		 Perhaps Arie might object
               y(nclump) = SQRT(xsum*xsum+ysum*ysum) / REAL(nsum)
c+debug
c	IF(p.EQ.3 .AND. b.EQ.2) THEN
c            write(*,*) 'before scale: x,y=',x(nclump),y(nclump)
c        ENDIF
c-debug
               CALL ampscal(y(nclump),
     *              calbflux(b,avidx(i-1)),scalmode)
c+debug
c	IF(p.EQ.3 .AND. b.EQ.2) THEN
c            write(*,*) 'after scale: x,y=',x(nclump),y(nclump)
c        ENDIF
c-debug
            ENDIF
         ENDIF
      ENDDO
      IF (MOD(p,2).EQ.0) CALL miniflip(nclump,y,flips)
      END
c----------------------------------------------------------------------
c*miniflip - flip phases into a continuous string
c:calibration, line up phases
c&lgm
c+
      SUBROUTINE miniflip(npts,phas,flips)
c
      INTEGER npts, flips(*)
      REAL    phas(*)
c
c   Input:
c       npts:   Number of points in phases array
c       phas:   phases to be played with in radians
c
c   Output:
c       phas:   output phases nicely unwrapped
c       flips:  record of number of 2pi flips applied to each point
c
c   miniFlip attempts to correct the phases for phase wrapping
c   It uses vector averaging, and hence needs to be supplied
c   with an array specifiying how vector averaging is done.
c   The source code is full of witty comments how it really
c   works.
c--
c-----------------------------------------------------------------------
c	Written:  13-jul-90   LGM
c       27-aug-90 lgm  Modified to do simple flipping when npts=2
c       22-oct-90 pjt  moved code - irrelevant
c
c >>> ../../src/inc/caldefs.h
c=======================================================================
c [caldefs.h]
c General include file that every calibration routine needs. It does not
c define (space for) data, but defines the constants that should be used
c in defining array-sizes.
c	18-nov-90 	added PI and TWOPI			PJT
c	 6-jul-91	V6.3 new MAXANTHC and MAXBASHC          pjt
c	26-sep-91       increased MAXUVPNT and MAXBREAK
c	 2-dec-91	V6.4 changed calbflux's dimensionality	PJT
c	19-apr-93	MAXSLOT from 20 to 36 for screwed mode-4  PJT
c			added MAXWIN from 8 (hardcoded) to 16
c	15-apr-94	MAXWIN is now in maxdim.h		PJT/mchw
c       19-dec-95       increase MAXANTHC from 6 to 9 !!!       pjt
c        9-Feb-99       increase MAXANTHC from 9 to 10 !       mchw
c       25-Apr-06       Increase MAXANTHC from 10 to 15 for CARMA ! mh
c=======================================================================
c >>> ../../src/inc/maxdim.h
c src/inc/cfg_maxdim.h.  Generated from maxdim.h.in by configure.
c TELESCOPE=carma
c=======================================================================
        CHARACTER*(*) MIRTEL
        PARAMETER(MIRTEL='carma')
        INTEGER   MAXBUF
        PARAMETER(MAXBUF=10000000)
c
        INTEGER   MAXDIM, MAXDIM2
        PARAMETER(MAXDIM=65536,MAXDIM2=8192)
c
        INTEGER   MAXANT,MAXANT2
        PARAMETER(MAXANT=64,MAXANT2=28)
c		maximum number of baselines
        INTEGER   MAXBASE
        PARAMETER(MAXBASE=1058)
        INTEGER   MAXBASE2
        PARAMETER(MAXBASE2=1058)
c
        INTEGER   MAXCHAN
        PARAMETER(MAXCHAN=8192)
c
        INTEGER   MAXWIN
        PARAMETER(MAXWIN=32)
c
        INTEGER   MAXWIDE
        PARAMETER(MAXWIDE=32)
c
        INTEGER   MAXFBIN
        PARAMETER(MAXFBIN=32)
c=======================================================================
c
c <<< ../../src/inc/maxdim.h
c=======================================================================
c >>> ../../src/inc/size.h
c=======================================================================
c	[size.h]
c
c  Include file used by calibration software
c
c  UL, RI, ULRI -- parameters which stand for LSB/USB and REAL/IMAG stuff
c
        integer UL, RI, ULRI
        parameter( UL = 2 )
        parameter( RI = 2 )
        parameter( ULRI = 4 )
c
c  SIZE -- lengths of reals/integers in number of bytes (IEEE/2s compl)
c
        integer SIZE
        parameter( SIZE = 4 )
c=======================================================================
c
c <<< ../../src/inc/size.h
c=======================================================================
c
c  SVERSION -- current version of cal format (consistency checks)
c              Version number is 10*MAJOR+MINOR
c              Datasets with a MAJOR difference, cannot be read
c              anymore, MINOR differences are normally compatible
c
      INTEGER SVERSION
      PARAMETER ( SVERSION = 64)
c
c MAXANTHC -- special Hat Creek MAXANT, to keep it small for us....
c MAXBASHC -- derived from MAXANTHC = max. number of baselines
c
c Now changed the number from Hat-Creek (10) to Cedar-Flat (15)
c although the name is the same.
c
      INTEGER MAXANTHC, MAXBASHC
      PARAMETER (MAXANTHC=15, MAXBASHC=((MAXANTHC*(MAXANTHC-1))/2))
c
c MAXUVPNT -- maximum number of UV points in time per track
c
      INTEGER   MAXUVPNT
      PARAMETER(MAXUVPNT=2000)
c
c  MAXSRC -- maximum number of sources in multi-source databases
c
      INTEGER MAXSRC
      PARAMETER( MAXSRC = 32 )
c
c  MAXBREAK -- maximum number of breakpoints on an interval
c
      INTEGER MAXBREAK
      PARAMETER( MAXBREAK = 10 )
c
c  MAXPOLY -- maximum number of polynomials on an interval
c             is normally one more than number of breakpoints, right?
c
      INTEGER MAXPOLY
      PARAMETER( MAXPOLY = MAXBREAK+1 )
c
c  MAXSLOT -- maximum number of polynomial slots
c             Allows for simultaneous presence of gcal & pcal format
c             The first 4 for gcal, last 16 for pcal
c             CALIB makes use of slot 5 and 6 for phase diff&mean
      INTEGER MAXSLOT
c      PARAMETER( MAXSLOT = 20 )
      PARAMETER( MAXSLOT = 36 )
c
c  MAXORDER -- highest allowed polynomial order
c             Don't set too high, inversions are already needed in
c             double precision this way.
      INTEGER MAXORDER
      PARAMETER( MAXORDER = 5 )
c
c  MAXWIN -- maximum number of windows - normally equals MAXSPECT = 8
c	     but temporarely increased to 16 to deal with mode=4
c	     problems.
c     INTEGER MAXWIN
c     PARAMETER ( MAXWIN = 16 )
c
c=======================================================================
c
c <<< ../../src/inc/caldefs.h
c >>> ../../src/inc/mirconst.h
c=======================================================================
c - mirconst.h  Include file for various fundamental physical constants.
c
c  History:
c    jm  18dec90  Original code.  Constants taken from the paper
c                 "The Fundamental Physical Constants" by E. Richard
c                 Cohen and Barry N. Taylor (PHYICS TODAY, August 1989).
c   pjt  13aug08  Aligned with ATNF
c   pjt  14nov08  updated from latest NIST values
c                 http://physics.nist.gov/cuu/Constants/index.html
c
c $Id: mirconst.h,v 1.3 2008/11/15 04:22:29 pteuben Exp $
c ----------------------------------------------------------------------
c  Pi.
      double precision DPI, DPI_2, DPI_4, DTWOPI
      parameter (DPI = 3.14159265358979323846D0)
      parameter (DTWOPI = DPI * 2D0)
      parameter (DPI_2  = DPI / 2D0)
      parameter (DPI_4  = DPI / 4D0)
c
      real PI, PI_2, PI_4, TWOPI
      parameter (PI    = DPI)
      parameter (TWOPI = DTWOPI)
      parameter (PI_2  = DPI_2)
      parameter (PI_4  = DPI_4)
c ----------------------------------------------------------------------
c  Angular conversion factors.
      double precision DAS2R, DD2R, DR2AS, DR2D
      parameter (DD2R  =  DPI / 180D0)
      parameter (DR2D  =  1D0 / DD2R)
      parameter (DAS2R = DD2R / 3600D0)
      parameter (DR2AS =  1D0 / DAS2R)
c
      real AS2R, D2R, R2AS, R2D
      parameter (D2R   = DD2R)
      parameter (R2D   = DR2D)
      parameter (AS2R  = DAS2R)
      parameter (R2AS  = DR2AS)
c ----------------------------------------------------------------------
c  Speed of light (meter/second).
      double precision DCMKS
      parameter (DCMKS = 299792458D0)
c
      real CMKS
      parameter (CMKS = DCMKS)
c ----------------------------------------------------------------------
c  Boltzmann constant (Joule/Kelvin).
      double precision DKMKS
      parameter (DKMKS = 1.3806504D-23)
c
      real KMKS
      parameter (KMKS = DKMKS)
c ----------------------------------------------------------------------
c  Planck constant (Joule-second).
      double precision DHMKS
      parameter (DHMKS = 6.62606896D-34)
c
      real HMKS
      parameter (HMKS = DHMKS)
c ----------------------------------------------------------------------
c  Planck constant divided by Boltzmann constant (Kelvin/GHz).
      double precision DHOVERK
      parameter (DHOVERK = 1D9 * DHMKS / DKMKS)
c
      real HOVERK
      parameter (HOVERK = DHOVERK)
c=======================================================================
c <<< ../../src/inc/mirconst.h
c
        INTEGER i,ic,loop
        REAL    avep,dphas,sum1,sum2,sum3
        REAL    rtemp,itemp,length,minlen
        LOGICAL fflag
c       CHARACTER text*80
c
c   If only one point, get out of here
c
        IF(npts .LE. 1) RETURN
c
c       Form length of string stretching between points on whole interval
c
        minlen = 0.0
        DO 50 i=1,npts-1
           flips(i) = 0
           minlen = minlen + abs(phas(i)-phas(i+1))
  50    CONTINUE
        flips(npts) = 0
c
c       See of length of string is shorter if all points are flipped
c             to positive values
c
        length = 0.0
        DO 100 ic=1,npts-1
           rtemp = phas(ic)
           IF(phas(ic).LT. 0.0) rtemp = phas(ic)+TWOPI
           itemp = phas(ic+1)
           IF(phas(ic+1).LT. 0.0) itemp = phas(ic+1)+TWOPI
           length = length + abs(rtemp-itemp)
  100   CONTINUE
c
c   if it is shorter, apply the flips
c
        IF(length .LT. minlen-0.1) THEN
c          CALL output(' Making all phases positive')
           DO 150 ic=1,npts
              IF(phas(ic).lt. 0.0) then
                  phas(ic) = phas(ic)+TWOPI
                  flips(ic) = flips(ic)+1
              ENDIF
  150      CONTINUE
        ENDIF
c
c   If there are only two point eject at this point.
c
        IF(npts .le. 2) RETURN
c
c      Now step through the points and see if there are still points
c      off by more than 3.3 rads. If so flip them
c
        DO 250 ic=1,npts-1
           IF(ABS(phas(ic+1)-phas(ic)) .GT. 3.3) THEN
              dphas = phas(ic+1)-phas(ic)
c              WRITE(text,'(''flipping after '',i2)') ic
c             CALL output(text)
              DO 200 i=ic+1,npts
                 flips(i) = flips(i) - ifix(1.1*dphas/abs(dphas))
                 phas(i)  = phas(i) - TWOPI*(dphas/abs(dphas))
  200         CONTINUE
           ENDIF
  250   CONTINUE
c
c      Now flip individual points if they are too far out of line with
c      their neighbors
c
        fflag = .TRUE.
        loop = 0
        DO WHILE (fflag .AND. loop .LT. 4)
           loop = loop + 1
           fflag = .FALSE.
           DO 350 i=1,npts
              sum1 = 0.0
              sum2 = 0.0
              sum3 = 0.0
              DO 300 ic=1,npts
                 IF(ic .NE. i) THEN
                    sum1 = sum1 + ABS((phas(ic)-phas(i))/(ic-i))
                    sum2 = sum2 + ABS((phas(ic)-(phas(i)+TWOPI))
     *                                  /(ic-i))
                    sum3 = sum3 + ABS((phas(ic)-(phas(i)-TWOPI))
     *                                  /(ic-i))
                 ENDIF
  300         CONTINUE
              if(sum2 .LT. sum1) THEN
c                WRITE(text,'(''flipping up point '',i2)') i
c                CALL output(text)
                 fflag    = .TRUE.
                 flips(i) = flips(i) + 1
                 phas(i)  = phas(i) + TWOPI
              ENDIF
              IF(sum3 .LT. sum1) THEN
c                WRITE(text,'(''flipping down point '',i2)') i
c                CALL output(text)
                 fflag    = .TRUE.
                 flips(i) = flips(i) - 1
                 phas(i)  = phas(i) - TWOPI
              ENDIF
  350      CONTINUE
        ENDDO
c
c      Form the average phase over the whole interval and apply
c            a phase flip to make it within +-pi
c
        avep = 0.
        DO 400 ic=1,npts
           avep = avep + phas(ic)
  400   CONTINUE
        avep = avep/npts
        IF(abs(avep) .gt. 3.15) THEN
           DO 500 ic=1,npts
              phas(ic) = phas(ic) - TWOPI*(avep/abs(avep))
              flips(ic) = flips(ic) - ifix(1.1*avep/abs(avep))
  500      CONTINUE
        ENDIF
c
        RETURN
        END
c
c*flipper - flip phases into a continuous string
c:calibration, line up phases
c&lgm
c+
        SUBROUTINE flipper(timave,timmax,basediff)
c
        REAL    timave,timmax
        INTEGER basediff(2,*)
c
c   Input:
c       timave    max time interval allowed between data points within
c                     a group of points to be vector averaged
c                     if timave=0, it is set to 4 minutes
c       timmax    max time interval over which to vector average data
c                     if timmax=0, it is set to 20 minutes
c
c   Output:
c       basediff  dummy array output for compatability - all zeros
c
c
c   Flipper attempts to correct the phases for phase wrapping
c   It uses vector averaging, and hence needs to be supplied
c   with an array specifiying how vector averaging is done.
c   The source code is full of witty comments how it really
c   works.
c-----------------------------------------------------------------------
c       Written:  13-jul-90   LGM
c       27-aug-90 lgm  Modified to do simple flipping when npts=2
c       22-oct-90 pjt  some witty bugs removed
c       18-nov-90 pjt  moved dummy 'basediff' up for documation reasons
c	 9-aug-91 pjt  count unflagged zero amps
c >>> ../../src/inc/caldefs.h
c=======================================================================
c [caldefs.h]
c General include file that every calibration routine needs. It does not
c define (space for) data, but defines the constants that should be used
c in defining array-sizes.
c	18-nov-90 	added PI and TWOPI			PJT
c	 6-jul-91	V6.3 new MAXANTHC and MAXBASHC          pjt
c	26-sep-91       increased MAXUVPNT and MAXBREAK
c	 2-dec-91	V6.4 changed calbflux's dimensionality	PJT
c	19-apr-93	MAXSLOT from 20 to 36 for screwed mode-4  PJT
c			added MAXWIN from 8 (hardcoded) to 16
c	15-apr-94	MAXWIN is now in maxdim.h		PJT/mchw
c       19-dec-95       increase MAXANTHC from 6 to 9 !!!       pjt
c        9-Feb-99       increase MAXANTHC from 9 to 10 !       mchw
c       25-Apr-06       Increase MAXANTHC from 10 to 15 for CARMA ! mh
c=======================================================================
c >>> ../../src/inc/maxdim.h
c src/inc/cfg_maxdim.h.  Generated from maxdim.h.in by configure.
c TELESCOPE=carma
c=======================================================================
        CHARACTER*(*) MIRTEL
        PARAMETER(MIRTEL='carma')
        INTEGER   MAXBUF
        PARAMETER(MAXBUF=10000000)
c
        INTEGER   MAXDIM, MAXDIM2
        PARAMETER(MAXDIM=65536,MAXDIM2=8192)
c
        INTEGER   MAXANT,MAXANT2
        PARAMETER(MAXANT=64,MAXANT2=28)
c		maximum number of baselines
        INTEGER   MAXBASE
        PARAMETER(MAXBASE=1058)
        INTEGER   MAXBASE2
        PARAMETER(MAXBASE2=1058)
c
        INTEGER   MAXCHAN
        PARAMETER(MAXCHAN=8192)
c
        INTEGER   MAXWIN
        PARAMETER(MAXWIN=32)
c
        INTEGER   MAXWIDE
        PARAMETER(MAXWIDE=32)
c
        INTEGER   MAXFBIN
        PARAMETER(MAXFBIN=32)
c=======================================================================
c
c <<< ../../src/inc/maxdim.h
c=======================================================================
c >>> ../../src/inc/size.h
c=======================================================================
c	[size.h]
c
c  Include file used by calibration software
c
c  UL, RI, ULRI -- parameters which stand for LSB/USB and REAL/IMAG stuff
c
        integer UL, RI, ULRI
        parameter( UL = 2 )
        parameter( RI = 2 )
        parameter( ULRI = 4 )
c
c  SIZE -- lengths of reals/integers in number of bytes (IEEE/2s compl)
c
        integer SIZE
        parameter( SIZE = 4 )
c=======================================================================
c
c <<< ../../src/inc/size.h
c=======================================================================
c
c  SVERSION -- current version of cal format (consistency checks)
c              Version number is 10*MAJOR+MINOR
c              Datasets with a MAJOR difference, cannot be read
c              anymore, MINOR differences are normally compatible
c
      INTEGER SVERSION
      PARAMETER ( SVERSION = 64)
c
c MAXANTHC -- special Hat Creek MAXANT, to keep it small for us....
c MAXBASHC -- derived from MAXANTHC = max. number of baselines
c
c Now changed the number from Hat-Creek (10) to Cedar-Flat (15)
c although the name is the same.
c
      INTEGER MAXANTHC, MAXBASHC
      PARAMETER (MAXANTHC=15, MAXBASHC=((MAXANTHC*(MAXANTHC-1))/2))
c
c MAXUVPNT -- maximum number of UV points in time per track
c
      INTEGER   MAXUVPNT
      PARAMETER(MAXUVPNT=2000)
c
c  MAXSRC -- maximum number of sources in multi-source databases
c
      INTEGER MAXSRC
      PARAMETER( MAXSRC = 32 )
c
c  MAXBREAK -- maximum number of breakpoints on an interval
c
      INTEGER MAXBREAK
      PARAMETER( MAXBREAK = 10 )
c
c  MAXPOLY -- maximum number of polynomials on an interval
c             is normally one more than number of breakpoints, right?
c
      INTEGER MAXPOLY
      PARAMETER( MAXPOLY = MAXBREAK+1 )
c
c  MAXSLOT -- maximum number of polynomial slots
c             Allows for simultaneous presence of gcal & pcal format
c             The first 4 for gcal, last 16 for pcal
c             CALIB makes use of slot 5 and 6 for phase diff&mean
      INTEGER MAXSLOT
c      PARAMETER( MAXSLOT = 20 )
      PARAMETER( MAXSLOT = 36 )
c
c  MAXORDER -- highest allowed polynomial order
c             Don't set too high, inversions are already needed in
c             double precision this way.
      INTEGER MAXORDER
      PARAMETER( MAXORDER = 5 )
c
c  MAXWIN -- maximum number of windows - normally equals MAXSPECT = 8
c	     but temporarely increased to 16 to deal with mode=4
c	     problems.
c     INTEGER MAXWIN
c     PARAMETER ( MAXWIN = 16 )
c
c=======================================================================
c
c <<< ../../src/inc/caldefs.h
c >>> ../../src/inc/calsubs.h
c=======================================================================
c	[calsubs.h]
c
c	Last update:    22-may-90	deleted pmode	PJT
c			18-dec-90	played with  /calmode/ [Arie/Peter]
c			 7-jul-91       new MAXBASHC parameter
c			11-dec-91	documentation formalized in doc format
c
c*calsubs_h -- header file for calibration
c:calibration, include
c&pjt
c+
c
c  time0 -- Julian time offset for all time measurements
        DOUBLE PRECISION time0
c
c  base(nbl) -- the baseline number and order
        INTEGER nbl, base(MAXBASHC)
c
c  version -- the read version of cal format
        INTEGER version
c
c  calsubs -- THE common block
        COMMON /calsubs/ time0, nbl, base, version
c
c
c  kludge before upgrading to the next CAL-SVERSION
        INTEGER scalmode
c
c	0:	(old system) fitting is done in K
c	1:	fitting is done in data space (K/Jy), i.e. the same is above
c      -1:	fitting is done in gain space (Jy/K)
c
c   For now, scalmode is set in calfit and calflag and such.
c   CAopen should get an extra stamp for this, see calio.h
c
        COMMON /calscal/scalmode
c--
c   Mode of phase/amp calibration in calflag/calib/...
c   [may be used in Arie's calib.for - but is internal for now]
c   nmode=1   amp
c	  2   phase
c         3   diff
c
c	INTEGER nmode
c	COMMON /calmode/nmode
c=======================================================================
c
c <<< ../../src/inc/calsubs.h
c >>> ../../src/inc/caldata.h
c=======================================================================
c       [caldata.h]
c       Header file for calibration data
c
c       Last update:    14-mar-90       added Sflag     PJT
c                       20-mar-90       srcindex now srcindex(MAXPNT)   PJT
c                        7-may-90       rdata(ULRI,MAXBASHC,MAXUVPNT)   PJT
c                        4-sep-90       baseline based calib stuff      PJT
c                       18-nov-90       more descriptive comments       PJT
c                       18-dec-90       played with rdata()             PJT
c                        7-jul-91       MAXBASE -> BAXMASHC             PJT
c                        2-dec-91       make fluxes time dependant, not
c                                       source dependant; =V6.4 fmt     PJT
c                       11-dec-91       documentation formalized in doc format
c*caldata_h -- header file for calibration data
c:calibration, include
c&pjt
c+
c   The calibration format on disk is split out in memory over several
c   common blocks, each of them described in a separate include file.
c
c
c <general header> (see also calsubs.h)
c       double time0            time to which all times are offset (JD)
c       int    nbl              number of baselines
c       int    base(nbl)        nbl baselines (notation: A1*256+A2)
c       int    version          version of the calibration format
c
c <data> (this caldata.h include file)
c   rtime
c       float  rtime(rcount)             offset times to time0
c   rdata
c       float  rdata(ULRI,nbl,rcount)    correllation data
c   rflag
c       int    rflag(UL,nbl,rcount)      flagged bad? (0=false, 1=true)
c   sindex
c       int    sindex(rcount)            source index number
c   sname
c       char*16 sname(scount)             list of sources
c
c
c
c  Rxxxx -- the actual calibration data
c
      INTEGER   rcount
      REAL      rtime(MAXUVPNT)
      REAL      rdata(ULRI, MAXBASHC, MAXUVPNT)
      INTEGER   rflag(UL, MAXBASHC, MAXUVPNT)
c
c  Sxxxx -- index for multiple source calibration format
c           (plstuff was added later and is not quite needed??)
c
      INTEGER   scount
      CHARACTER sname(MAXSRC)*16
      INTEGER   sindex(MAXUVPNT), sflag(MAXUVPNT)
      REAL      plstuff(4,MAXSRC)
c
c  Bxxxx - list of break points
c
      REAL      btime(MAXBREAK, 2, MAXBASHC)
      INTEGER   bcount(2, MAXBASHC)
c
c  Xxxxx - odds and ends, should not really have to exist
c          are merely there for planets
c
      REAL      volts(MAXUVPNT)
c
c  baseline based calibrator fluxes, per time
c
      REAL      calbflux(MAXBASHC,MAXUVPNT)
c
c
c  the common blocks with all the data
c
      COMMON /caldatr/ rcount, scount, rtime, rdata, rflag,
     *                 sindex, btime, bcount, sflag, plstuff,volts
      COMMON /caldatc/ sname
      COMMON /caldatp/ calbflux
c--
c=======================================================================
c
c <<< ../../src/inc/caldata.h
c >>> ../../src/inc/calpoly.h
c=======================================================================
c	[calpoly.h]
c
c	last update: 26-apr-90	new poly's
c		     18-nov-90  descriptive comments
c		      7-jul-91  new MAXBASHC parameter
c*calpoly_h -- header file for calibration data
c:calibration, include
c&pjt
c+
c
c  order -- current polynomial order for a slot
c
      INTEGER order(MAXSLOT)
c
c
c  pcount -- number of polynomials in a (slot,baseline) pair
c
      INTEGER pcount(MAXSLOT, MAXBASHC)
c
c
c  tvalid - validity of time interval
c		(min & max time-range; breakpoints; slotcode; baseline)
c
      REAL tvalid(2,MAXBREAK+1,MAXSLOT,MAXBASHC)
c
c  poly -- actual polynomial coefficients
c		(order; breakpoints, slotcode, baseline)
c
      REAL poly( 0:MAXORDER, MAXBREAK+1, MAXSLOT, MAXBASHC )
c
c
c  CALPOLY -- the common block
c
      COMMON /calpoly/ pcount, order, tvalid, poly
c--
c=======================================================================
c <<< ../../src/inc/calpoly.h
c >>> ../../src/inc/mirconst.h
c=======================================================================
c - mirconst.h  Include file for various fundamental physical constants.
c
c  History:
c    jm  18dec90  Original code.  Constants taken from the paper
c                 "The Fundamental Physical Constants" by E. Richard
c                 Cohen and Barry N. Taylor (PHYICS TODAY, August 1989).
c   pjt  13aug08  Aligned with ATNF
c   pjt  14nov08  updated from latest NIST values
c                 http://physics.nist.gov/cuu/Constants/index.html
c
c $Id: mirconst.h,v 1.3 2008/11/15 04:22:29 pteuben Exp $
c ----------------------------------------------------------------------
c  Pi.
      double precision DPI, DPI_2, DPI_4, DTWOPI
      parameter (DPI = 3.14159265358979323846D0)
      parameter (DTWOPI = DPI * 2D0)
      parameter (DPI_2  = DPI / 2D0)
      parameter (DPI_4  = DPI / 4D0)
c
      real PI, PI_2, PI_4, TWOPI
      parameter (PI    = DPI)
      parameter (TWOPI = DTWOPI)
      parameter (PI_2  = DPI_2)
      parameter (PI_4  = DPI_4)
c ----------------------------------------------------------------------
c  Angular conversion factors.
      double precision DAS2R, DD2R, DR2AS, DR2D
      parameter (DD2R  =  DPI / 180D0)
      parameter (DR2D  =  1D0 / DD2R)
      parameter (DAS2R = DD2R / 3600D0)
      parameter (DR2AS =  1D0 / DAS2R)
c
      real AS2R, D2R, R2AS, R2D
      parameter (D2R   = DD2R)
      parameter (R2D   = DR2D)
      parameter (AS2R  = DAS2R)
      parameter (R2AS  = DR2AS)
c ----------------------------------------------------------------------
c  Speed of light (meter/second).
      double precision DCMKS
      parameter (DCMKS = 299792458D0)
c
      real CMKS
      parameter (CMKS = DCMKS)
c ----------------------------------------------------------------------
c  Boltzmann constant (Joule/Kelvin).
      double precision DKMKS
      parameter (DKMKS = 1.3806504D-23)
c
      real KMKS
      parameter (KMKS = DKMKS)
c ----------------------------------------------------------------------
c  Planck constant (Joule-second).
      double precision DHMKS
      parameter (DHMKS = 6.62606896D-34)
c
      real HMKS
      parameter (HMKS = DHMKS)
c ----------------------------------------------------------------------
c  Planck constant divided by Boltzmann constant (Kelvin/GHz).
      double precision DHOVERK
      parameter (DHOVERK = 1D9 * DHMKS / DKMKS)
c
      real HOVERK
      parameter (HOVERK = DHOVERK)
c=======================================================================
c <<< ../../src/inc/mirconst.h
c-----------------------------------------------------------------------
        INTEGER timidx(MAXUVPNT),finalidx(MAXUVPNT),i,fincount
        INTEGER s1,b,subidx(MAXUVPNT),bp,count,ccount,iit,bcnt
        INTEGER clump(MAXUVPNT),flips(MAXUVPNT),brkpt(MAXBREAK+2)
        INTEGER flipcnt(MAXUVPNT),z
c	INTEGER dflip
        REAL    xtim(MAXUVPNT),cphas(MAXUVPNT),t,dphas,signcl(3)
        REAL    rtemp,itemp,taver,tmax,brkphas(2,MAXBREAK+2)
        LOGICAL add
c	CHARACTER text*80
c
c
c   Fill time order index array for cal data from time array
        call sortidxr(rcount,rtime,timidx)
c Loop through each baseline(b=1..nbl) and sideband(s1=1,2)
c	count number of zero's amp's in 'z'
c
        z=0
c
        do 400 s1=1,2
        do 300 b=1,nbl
c
c convert real/imag data to amp/phas data
c
        do 50 i=1,rcount
           rtemp = rdata(2*s1-1,b,i)
           itemp = rdata(2*s1,b,i)
           IF (rtemp.EQ.0.AND.itemp.EQ.0.AND.rflag(s1,b,i).EQ.1) z=z+1
           rdata(2*s1-1,b,i) = sqrt(rtemp*rtemp + itemp*itemp)
           IF(rdata(2*s1-1,b,i) .GT. 0.0) then
              rdata(2*s1,b,i) = atan2(itemp,rtemp)
           ELSE
              rdata(2*s1,b,i) = 0.0
           ENDIF
   50   continue
c
c   Drop point from final index array if it is either the wrong source
c      or its data flag is bad
        fincount = 0
        do 100 i=1,rcount
           if(rflag(s1,b,timidx(i)).eq.1  .AND.
     *                   sflag(timidx(i)).eq.1) then
              fincount = fincount + 1
              finalidx(fincount) = timidx(i)
           endif
  100   continue
c Loop through for interval between breaks: 'bp' counts the intervals,
c starting at 0 through bcnt (bcnt>=0)
        bcnt = bcount(s1,b)
        DO 200 bp=0,bcnt
c
c   Form sub final index for interval
c
c	   fill subidx array
c
            count = 0
            DO  110 iit=1,fincount
               i = finalidx(iit)
               add = .FALSE.
               t = rtime(i)
               IF( (rflag(s1,b,i).EQ.1).AND.(sflag(i).EQ.1) ) THEN
                  IF (bcnt.EQ.0) THEN
                    add = .TRUE.
                  ELSEIF (bcnt.EQ.1) THEN
                    IF (bp.EQ.0) THEN
                        IF (t.LE.btime(1,s1,b)) add = .TRUE.
                    ELSE
                        IF (t.GT.btime(1,s1,b)) add = .TRUE.
                    ENDIF
                  ELSE
                    IF (bp.EQ.0) THEN
                        IF (t.LE.btime(1,s1,b)) add = .TRUE.
                    ELSEIF (bp.EQ.bcnt) THEN
                        IF (t.GT.btime(bcnt,s1,b)) add = .TRUE.
                    ELSE
                        IF (t.GT.btime(bp,s1,b) .AND.
     *                      t.LE.btime(bp+1,s1,b)) add = .TRUE.
                    ENDIF
                  ENDIF
               ELSE
                  CALL bug('w','flipper: SHOULD NEVER GET HERE')
               ENDIF
c
               if (add) then
                  count         = count + 1
                  subidx(count) = i
                  brkpt(bp+1)   = iit
               endif
  110       continue
c
c
c   Call clump averager for phase, if enough points
c
           IF (count.GT.0) THEN
           taver = timave
           tmax  = timmax
           if(taver .le. 0.0) taver = 4.0/1440.0
           if(tmax .le. 0.0) tmax  = 20.0/1440.0
           call vectav(b,2*s1,count,subidx,
     *                  clump,ccount,xtim,cphas,taver,tmax)
c
c	   write(text,'(''s1,b,bp= '',3(i2,1x))') s1,b,bp
c	   call output(text)
c	   write(text,'(''cphas = '',10(f5.1,1x))') (cphas(i),i=1,ccount)
c	   call output(text)
c
c  If there are more than two clumps then test and correct phase wraps
c
           if(ccount .ge. 2) then
c
              call miniflip(ccount,cphas,flipcnt)
c
c	      write(text,'('' flips= '',12(i2,1x))')
c     1				(flipcnt(i),i=1,ccount)
c	      call output(text)
c
c       assign the number of 2pi flips that have been applied
c            to each individual data point within clumps
c
              do 150 i=1,count
                 flips(subidx(i)) = flipcnt(clump(i))
                 rdata(2*s1,b,subidx(i)) = rdata(2*s1,b,subidx(i))
     *                          + TWOPI*flips(subidx(i))
                 dphas = cphas(clump(i))-rdata(2*s1,b,subidx(i))
                 if(abs(dphas) .gt. PI) then
                    rdata(2*s1,b,subidx(i))=rdata(2*s1,b,subidx(i))
     *                          + TWOPI*(dphas/abs(dphas))
                 endif
  150         continue
c
c              -> ccount.lt.2
           else
c
              do 170 i=1,count
                 dphas = cphas(clump(i))-rdata(2*s1,b,subidx(i))
                 if(abs(dphas) .gt. PI) then
                    rdata(2*s1,b,subidx(i))=rdata(2*s1,b,subidx(i))
     *                          + TWOPI*(dphas/abs(dphas))
                 endif
  170         continue
c
           endif
c
           brkphas(1,bp+1) = cphas(1)
           brkphas(2,bp+1) = cphas(ccount)
c		and if count.eq.0:
          ELSE
            brkphas(1,bp+1) = 0.0
            brkphas(2,bp+1) = 0.0
          ENDIF
  200   continue
        brkpt(bcnt+2)     = fincount
        brkphas(1,bcnt+2) = brkphas(1,bcnt+1)
        brkphas(2,bcnt+2) = brkphas(2,bcnt+1)
c
c   7) if number of 2pi flips found across adjacent intervals are
c         not in agreement, force them to agree.
c
c *** 30-jul-90 temp. disabled breakpoint alignment (lgm)
c	do 240 bp=0,bcnt
c	   dphas = abs(brkphas(1,bp+2)-brkphas(2,bp+1))
c           if(dphas .gt. 3.3) then
c              dflip = -1.01*dphas/abs(dphas)
cc	      call output('Doing break flip')
c              brkphas(2,bp+2) = brkphas(2,bp+2) + dflip*TWOPI
c	      do 220 i=brkpt(bp+1)+1,brkpt(bp+2)
c		 flips(finalidx(i)) = flips(finalidx(i)) + dflip
c		 rdata(2*s1,b,finalidx(i)) = rdata(2*s1,b,finalidx(i))
c     1				+ dflip*TWOPI
c  220         continue
c	   endif
c  240   continue
c *** 30-jul-90 temp. disabled breakpoint alignment (lgm)
c       -- endof b=1,nbl loop
  300   continue
c
c Check to see if a 2pi multiple has been slipped into the closure
c phase. If so, correct it. -- WARNING -- assumes 3 baselines ---- WARNING
c Warning: fincount, etc. are redefined on every baseline (the 300 loop)
c          hence this is extremely strange coding
c
        if(nbl .eq. 3) then
           call getclo3(nbl,base,signcl)
           rtemp = 0.0
           do 320 i=1,fincount
              rtemp = rtemp + signcl(1)*rdata(2*s1,1,finalidx(i)) +
     *                  signcl(2)*rdata(2*s1,2,finalidx(i)) +
     *                  signcl(3)*rdata(2*s1,3,finalidx(i))
  320      continue
           rtemp = rtemp/fincount
           if(abs(rtemp) .gt. 3.0) then
c	      call output('Doing closure flip')
              do 340 i=1,fincount
                rdata(2*s1,3,finalidx(i))=rdata(2*s1,3,finalidx(i))-
     *                    (rtemp/abs(rtemp))*TWOPI*signcl(3)
  340         continue
           endif
        else
           call bug('w','FLIPPER: No closure phase flipping done')
           call bug('w','FLIPPER: Number of baselines .ne. 3')
        endif
c        -- endof s1=1,2 loop
  400   continue
        IF (z.GT.0)CALL bug('w','FLIPPER: some unflagged zero amp data')
c
c
c  Give fake zeros to basediff so we are compatable with the needs of
c  calfit
        do 500 b=1,nbl
        do 500 s1=1,2
           basediff(s1,b) = 0
  500   continue
c
        return
        end
c
c*getclo3 -- Return sign for closure calculation for 3 baselines
c:calibration,
c&lgm
c+
        subroutine getclo3(nbl,base,signcl)
c
c   Returns sign for closure calculation for 3 baselines
c   WARNING::: THIS ONLY WORKS FOR # ANTENNAS
c
c   Input:
c       nbl --   (integer)  lenght of base() array
c       base --  (integer)  array containing A1*256+A2 baselines
c   Output:
c       signcl -- (real)    array filled with +/- 1.0 for closure such that
c                           $\sum_{i=1}^{nbl}{signcl(i)*\phi{i}}=0$
c
        real signcl(*)
        integer nbl, base(*)
c--
        integer i
        do 100 i=1,nbl
           if(base(i) .eq. 259) then
              signcl(i) = -1.0
           else
              signcl(i) = 1.0
           endif
  100   continue
        return
        end
