
/* System dependent initialisation. */

#define FORTRAN_CVT_INT 0
#define FORTRAN_CVT_LOG 0
typedef int fort_integer;
typedef int fort_logical;
typedef long fort_ptrdiff;
typedef float fort_real;
typedef double fort_double;
char *zterm(char *string,int length);
void pad(char *string,int length);
int *iface_iarr(int n);
void iface_f2c_icvt(fort_integer *in,int *out,int n);
void iface_c2f_icvt(int *in,fort_integer *out,int n);
int *iface_larr(int n);
void iface_f2c_lcvt(fort_logical *in,int *out,int n);
void iface_c2f_lcvt(int *in,fort_logical *out,int n);
/************************************************************************/
/*									*/
/*  Convert between FORTRAN and C data types.				*/
/*                                                                      */
/*  History:                                                            */
/*    18sep05 rjs  Original version.                                    */
/*    26nov05 rjs  Supported logicals as well.				*/
/*                                                                      */
/************************************************************************/

#if defined(HAVE_CONFIG_H) && HAVE_CONFIG_H
#include "config.h"
#endif

#include <stddef.h>
#include <stdlib.h>

#define BUFF_MIN 1024
static int *buffer;
static int bsize = 0;
/************************************************************************/
int *iface_iarr(int n)
{
  if(n < BUFF_MIN)n = BUFF_MIN;
  if(n > bsize){
    if(bsize > 0){
      buffer = (int *)realloc(buffer,n*sizeof(int));
    }else{
      buffer = (int *)malloc(n*sizeof(int));
    }
    bsize = n;
  }
  return buffer;
}
/************************************************************************/
int *iface_larr(int n)
{
  if(n < BUFF_MIN)n = BUFF_MIN;
  if(n > bsize){
    if(bsize > 0){
      buffer = (int *)realloc(buffer,n*sizeof(int));
    }else{
      buffer = (int *)malloc(n*sizeof(int));
    }
    bsize = n;
  }
  return buffer;
}
/************************************************************************/
void iface_f2c_icvt(fort_integer *in,int *out,int n)
{
  int i;
  for(i=0;i<n;i++)*out++ = *in++;
}
/************************************************************************/
void iface_c2f_icvt(int *in,fort_integer *out,int n)
{
  int i;
  for(i=0;i<n;i++)*out++ = *in++;
}
/************************************************************************/
void iface_f2c_lcvt(fort_logical *in,int *out,int n)
{
  int i;
  for(i=0;i<n;i++)*out++ = *in++;
}
/************************************************************************/
void iface_c2f_lcvt(int *in,fort_logical *out,int n)
{
  int i;
  for(i=0;i<n;i++)*out++ = *in++;
}

