
/* System dependent initialisation. */

#define FORTRAN_CVT_INT 0
#define FORTRAN_CVT_LOG 0
typedef int fort_integer;
typedef int fort_logical;
typedef long fort_ptrdiff;
typedef float fort_real;
typedef double fort_double;
char *zterm(char *string,int length);
void pad(char *string,int length);
int *iface_iarr(int n);
void iface_f2c_icvt(fort_integer *in,int *out,int n);
void iface_c2f_icvt(int *in,fort_integer *out,int n);
int *iface_larr(int n);
void iface_f2c_lcvt(fort_logical *in,int *out,int n);
void iface_c2f_lcvt(int *in,fort_logical *out,int n);
/************************************************************************/
/*                                                                      */
/*    Converter from Fortran to C calling sequence                      */
/*            For MIRIAD to MIR conversion                              */
/*  History:                                                            */
/*    dnf  15mar06  initial version                                     */
/************************************************************************/
#if defined(HAVE_CONFIG_H) && HAVE_CONFIG_H
#include "config.h"
#endif

#include <string.h>
#include <sys/types.h>
#include <unistd.h>
#include "miriad.h"
#include "sysdep.h"
/************************************************************************/
void mirinit_(fname,fname_len)
char *fname;
int fname_len;
{
  mirInit_c(zterm(fname,fname_len));
}
/************************************************************************/
void mirclose_()
{
  mirClose_c();
}
/************************************************************************/
void inwrite_(conid,icocd,traid,inhid,ints,itq,az,el,ha,iut,ireftime,dhrs,vc,ivctype,sx,sy,sz,rinteg,proid,souid,isource,ipos,offx,offy,iofftype,ira,idec,rar,decr,epoch,sflux,size)
fort_integer *conid;
fort_integer *icocd;
fort_integer *traid;
fort_integer *inhid;
fort_integer *ints;
fort_integer *itq;
fort_real *az;
fort_real *el;
fort_real *ha;
fort_integer *iut;
fort_integer *ireftime;
fort_double *dhrs;
fort_real *vc;
fort_integer *ivctype;
fort_double *sx;
fort_double *sy;
fort_double *sz;
fort_real *rinteg;
fort_integer *proid;
fort_integer *souid;
fort_integer *isource;
fort_integer *ipos;
fort_real *offx;
fort_real *offy;
fort_integer *iofftype;
fort_integer *ira;
fort_integer *idec;
fort_double *rar;
fort_double *decr;
fort_real *epoch;
fort_real *sflux;
fort_real *size;
{ 
  inWrite_c(*conid, *icocd, *traid, *inhid, *ints, *itq, 
    *az, *el, *ha, *iut, *ireftime, *dhrs, *vc, 
    *ivctype, *sx, *sy, *sz, *rinteg, *proid, *souid, 
    *isource, *ipos, *offx, *offy, *iofftype, *ira, 
    *idec, *rar, *decr, *epoch, *sflux, *size);
}
/************************************************************************/
void blwrite_(blhid,inhid,isb,ipol,pa,iaq,ibq,icq,ioq,irec,iifc,u,v,w,prbl,angres,vis,coh,sigcoh,csnr,vflux,cnoise,avedhrs,ampav,phaave,tpvar,blsid,itel1,itel2,iblcd,ble,bln,blu,soid)
fort_integer *blhid;
fort_integer *inhid;
fort_integer *isb;
fort_integer *ipol;
fort_real *pa;
fort_integer *iaq;
fort_integer *ibq;
fort_integer *icq;
fort_integer *ioq;
fort_integer *irec;
fort_integer *iifc;
fort_real *u;
fort_real *v;
fort_real *w;
fort_real *prbl;
fort_real *angres;
fort_real *vis;
fort_real *coh;
fort_real *sigcoh;
fort_real *csnr;
fort_real *vflux;
fort_real *cnoise;
fort_double *avedhrs;
fort_real *ampav;
fort_real *phaave;
fort_real *tpvar;
fort_integer *blsid;
fort_integer *itel1;
fort_integer *itel2;
fort_integer *iblcd;
fort_real *ble;
fort_real *bln;
fort_real *blu;
fort_integer *soid;
{
  blWrite_c(*blhid, *inhid, *isb, *ipol, *pa, *iaq,
    *ibq, *icq, *ioq, *irec, *iifc, *u, *v, *w,
    *prbl, *angres, *vis, *coh, *sigcoh, *csnr, *vflux,
    *cnoise, *avedhrs, *ampav, *phaave, *tpvar, *blsid,
    *itel1, *itel2, *iblcd, *ble, *bln, *blu, *soid);
}
/************************************************************************/
void spwrite_(sphid,blhid,inhid,igq,ipq,iband,ipstate,tau0,vel,vres,ivtype,fsky,fres,tssb,integ,wt,itaper,snoise,nch,nrec,dataoff,linid,itrans,rfreq,pasid,gaiidamp,gaiidpha,flcid,atmid)
fort_integer *sphid;
fort_integer *blhid;
fort_integer *inhid;
fort_integer *igq;
fort_integer *ipq;
fort_integer *iband;
fort_integer *ipstate;
fort_real *tau0;
fort_double *vel;
fort_real *vres;
fort_integer *ivtype;
fort_double *fsky;
fort_real *fres;
fort_real *tssb;
fort_real *integ;
fort_real *wt;
fort_integer *itaper;
fort_real *snoise;
fort_integer *nch;
fort_integer *nrec;
fort_integer *dataoff;
fort_integer *linid;
fort_integer *itrans;
fort_double *rfreq;
fort_integer *pasid;
fort_integer *gaiidamp;
fort_integer *gaiidpha;
fort_integer *flcid;
fort_integer *atmid;
{
  spWrite_c(*sphid, *blhid, *inhid, *igq, *ipq, *iband,
    *ipstate, *tau0, *vel, *vres, *ivtype, *fsky,
    *fres, *tssb, *integ, *wt, *itaper, *snoise, *nch,
    *nrec, *dataoff, *linid, *itrans, *rfreq, *pasid,
    *gaiidamp, *gaiidpha, *flcid, *atmid);
}

/************************************************************************/
void codewrite_(v_name,icode,code,ncode,v_name_len,code_len)
char *v_name;
int v_name_len;
fort_integer *icode;
char *code;
int code_len;
fort_integer *ncode;
{
  codeWrite_c(zterm(v_name,v_name_len), *icode, zterm(code,code_len), *ncode);
}
/************************************************************************/
void viswrite_(re,im,numvis,startvis,nbytes)
fort_real *re;
fort_real *im;
fort_integer *numvis;
fort_integer *startvis;
fort_integer *nbytes;
{
  visWrite_c(re, im, *numvis, *startvis, nbytes);
}
