c************************************************************************
c  History:
c    rjs  Dark-ages Original version.
c    rjs  19feb90   Fixed some comments.
c    rjs   4feb91   Ability to set random number generator seed.
c    rjs   7jan93   Include code for HP-UX machines, and reorganise defines.
c    rjs  xxjan93  Original version.
c    mjs  24feb93  Added some doc lines; no code mods.
c    rjs   7jul93  Include "ran" function here.
c    mjs  09mar94  Mods for sgi-only (mips).
c    rjs  25jan95  Mods for linux.
c    rjs  18aug95  Get it to work on SGI.
c    rjs  18sep95  Did I screw up in the above??I don't understand whats
c		   happened to the code.
c    rjs  24oct99  Added "save" statement in "ran" function.
c    rjs  04jul00  Use double precision arithmetic in "ran" to avoid some
c		   machine rounding biases.
c    rjs  18oct00  Setting the seedon "vms-style" machines was not working.
c    mc   12mar07  external for ran fixes gfortran problem
c    pjt  20mar07  merged previous MIR4 fortran standards
c
c $Id: noise.for,v 1.4 2007/03/20 12:19:23 pteuben Exp $
c************************************************************************
c
c  Choose which random number style we are to use. We have three choices:
c  vms, cft or unix style. You also have the choice of including the
c  "ran" function.
c
c************************************************************************
c*RandSet -- Set random number generator seed.
c&rjs
c:random-variables,noise
c+
        subroutine RandSet(seed)
c
        integer seed
c
c  This sets the seed of the random number generator. Future sequences
c  of random numbers will be generated from this seed.
c
c  Input:
c    seed	Some "random" integer value, which is the seed to be
c		used.
c--
c------------------------------------------------------------------------`
        real dummy
        real rand
        dummy = rand(seed)
        end
c************************************************************************
c*Uniform -- Return uniformly distributed random variables.
c&rjs
c:random-variables,noise
c+
        subroutine uniform(data,n)
c
        integer n
        real data(n)
c
c  Generate uniformly distributed noise, in the range [0,1]. This works
c  on any machine.
c
c  Inputs:
c    n		Number of random numbers to produce.
c
c  Output:
c    data	An array of uniformly distributed random numbers.
c--
c  Externals Called:
c    ran,rand or ranf
c		A random number generator which produces uniform variates
c		in [0,1].
c
c------------------------------------------------------------------------
        integer i
        real rand
        do i=1,n
          data(i) = rand(0)
        enddo
        end
c************************************************************************
c*Gaus -- Generate gaussianly distributed random variables.
c&rjs
c:random-variables,noise
c+
        subroutine gaus(data,n)
c
        integer n
        real data(n)
c
c  Generate gaussian noise. This works on any machine, but the Gaussian
c  noise it produces is system dependent and not extremely accurate.
c
c  Gaussian noise is produced by adding 12 variates uniformly distributed
c  in [0,1], then subtracting 6. This will have zero
c  mean, and a variance of 1, and by the Central Limit Theorem, will
c  approximate gaussian noise.
c
c  Inputs:
c    n		Number of gaussian numbers to produce.
c
c  Output:
c    data	An array of gaussian noise.
c--
c  TODO:  what about the Box-Mueller (polar) method
c         see Knuth, vol. 2, p. 104.
c------------------------------------------------------------------------
c >>> ../../src/inc/maxdim.h
c src/inc/cfg_maxdim.h.  Generated from maxdim.h.in by configure.
c TELESCOPE=carma
c=======================================================================
        CHARACTER*(*) MIRTEL
        PARAMETER(MIRTEL='carma')
        INTEGER   MAXBUF
        PARAMETER(MAXBUF=10000000)
c
        INTEGER   MAXDIM, MAXDIM2
        PARAMETER(MAXDIM=65536,MAXDIM2=8192)
c
        INTEGER   MAXANT,MAXANT2
        PARAMETER(MAXANT=64,MAXANT2=28)
c		maximum number of baselines
        INTEGER   MAXBASE
        PARAMETER(MAXBASE=1058)
        INTEGER   MAXBASE2
        PARAMETER(MAXBASE2=1058)
c
        INTEGER   MAXCHAN
        PARAMETER(MAXCHAN=8192)
c
        INTEGER   MAXWIN
        PARAMETER(MAXWIN=32)
c
        INTEGER   MAXWIDE
        PARAMETER(MAXWIDE=32)
c
        INTEGER   MAXFBIN
        PARAMETER(MAXFBIN=32)
c=======================================================================
c
c <<< ../../src/inc/maxdim.h
        integer i,j,l,ltot
        real buf(MAXDIM)
c
c  Initialise the output with a uniformly distributed variable.
c
        call uniform(data,n)
c
c  Add another 11 uniformly distributed numbers. Use a strip-mine
c  approach in case buf is too small.
c
        do j=2,12
          do l=1,n,MAXDIM
            ltot = min(n-l+1,MAXDIM)
            call uniform(buf,ltot)
            do i=1,ltot
              data(i+l-1) = data(i+l-1) + buf(i)
            enddo
          enddo
        enddo
c
c  Subtract off the mean value. The result should be roughly gaussianly
c  distributed with 0 mean and variance of 1.
c
        do i=1,n
          data(i) = data(i) - 6
        enddo
c
        end
c************************************************************************
