c squares, lsqfill, solve, lsqsault,
c*squares -- compute sums-of-squares for lsqfill
c:Polynomials, Calibration, Least-Squares
c& pjt
c+
        SUBROUTINE squares( count, x, y, pmax )
c
        INTEGER count, pmax
        REAL    x(*), y(*)
c
c  Inputs:
c	count -- the number of data points
c	x     -- independent variable
c	y     -- dependent variable
c	pmax  -- polynomial order of fit
c
c--
c
c  14 jul 90 - Modified to do fits in double precision, lgm
c  30 nov 91 - some re-format for readability, pjt
c
c >>> ../../src/inc/caldefs.h
c=======================================================================
c [caldefs.h]
c General include file that every calibration routine needs. It does not
c define (space for) data, but defines the constants that should be used
c in defining array-sizes.
c	18-nov-90 	added PI and TWOPI			PJT
c	 6-jul-91	V6.3 new MAXANTHC and MAXBASHC          pjt
c	26-sep-91       increased MAXUVPNT and MAXBREAK
c	 2-dec-91	V6.4 changed calbflux's dimensionality	PJT
c	19-apr-93	MAXSLOT from 20 to 36 for screwed mode-4  PJT
c			added MAXWIN from 8 (hardcoded) to 16
c	15-apr-94	MAXWIN is now in maxdim.h		PJT/mchw
c       19-dec-95       increase MAXANTHC from 6 to 9 !!!       pjt
c        9-Feb-99       increase MAXANTHC from 9 to 10 !       mchw
c       25-Apr-06       Increase MAXANTHC from 10 to 15 for CARMA ! mh
c=======================================================================
c >>> ../../src/inc/maxdim.h
c src/inc/cfg_maxdim.h.  Generated from maxdim.h.in by configure.
c TELESCOPE=carma
c=======================================================================
        CHARACTER*(*) MIRTEL
        PARAMETER(MIRTEL='carma')
        INTEGER   MAXBUF
        PARAMETER(MAXBUF=10000000)
c
        INTEGER   MAXDIM, MAXDIM2
        PARAMETER(MAXDIM=65536,MAXDIM2=8192)
c
        INTEGER   MAXANT,MAXANT2
        PARAMETER(MAXANT=64,MAXANT2=28)
c		maximum number of baselines
        INTEGER   MAXBASE
        PARAMETER(MAXBASE=1058)
        INTEGER   MAXBASE2
        PARAMETER(MAXBASE2=1058)
c
        INTEGER   MAXCHAN
        PARAMETER(MAXCHAN=8192)
c
        INTEGER   MAXWIN
        PARAMETER(MAXWIN=32)
c
        INTEGER   MAXWIDE
        PARAMETER(MAXWIDE=32)
c
        INTEGER   MAXFBIN
        PARAMETER(MAXFBIN=32)
c=======================================================================
c
c <<< ../../src/inc/maxdim.h
c=======================================================================
c >>> ../../src/inc/size.h
c=======================================================================
c	[size.h]
c
c  Include file used by calibration software
c
c  UL, RI, ULRI -- parameters which stand for LSB/USB and REAL/IMAG stuff
c
        integer UL, RI, ULRI
        parameter( UL = 2 )
        parameter( RI = 2 )
        parameter( ULRI = 4 )
c
c  SIZE -- lengths of reals/integers in number of bytes (IEEE/2s compl)
c
        integer SIZE
        parameter( SIZE = 4 )
c=======================================================================
c
c <<< ../../src/inc/size.h
c=======================================================================
c
c  SVERSION -- current version of cal format (consistency checks)
c              Version number is 10*MAJOR+MINOR
c              Datasets with a MAJOR difference, cannot be read
c              anymore, MINOR differences are normally compatible
c
      INTEGER SVERSION
      PARAMETER ( SVERSION = 64)
c
c MAXANTHC -- special Hat Creek MAXANT, to keep it small for us....
c MAXBASHC -- derived from MAXANTHC = max. number of baselines
c
c Now changed the number from Hat-Creek (10) to Cedar-Flat (15)
c although the name is the same.
c
      INTEGER MAXANTHC, MAXBASHC
      PARAMETER (MAXANTHC=15, MAXBASHC=((MAXANTHC*(MAXANTHC-1))/2))
c
c MAXUVPNT -- maximum number of UV points in time per track
c
      INTEGER   MAXUVPNT
      PARAMETER(MAXUVPNT=2000)
c
c  MAXSRC -- maximum number of sources in multi-source databases
c
      INTEGER MAXSRC
      PARAMETER( MAXSRC = 32 )
c
c  MAXBREAK -- maximum number of breakpoints on an interval
c
      INTEGER MAXBREAK
      PARAMETER( MAXBREAK = 10 )
c
c  MAXPOLY -- maximum number of polynomials on an interval
c             is normally one more than number of breakpoints, right?
c
      INTEGER MAXPOLY
      PARAMETER( MAXPOLY = MAXBREAK+1 )
c
c  MAXSLOT -- maximum number of polynomial slots
c             Allows for simultaneous presence of gcal & pcal format
c             The first 4 for gcal, last 16 for pcal
c             CALIB makes use of slot 5 and 6 for phase diff&mean
      INTEGER MAXSLOT
c      PARAMETER( MAXSLOT = 20 )
      PARAMETER( MAXSLOT = 36 )
c
c  MAXORDER -- highest allowed polynomial order
c             Don't set too high, inversions are already needed in
c             double precision this way.
      INTEGER MAXORDER
      PARAMETER( MAXORDER = 5 )
c
c  MAXWIN -- maximum number of windows - normally equals MAXSPECT = 8
c	     but temporarely increased to 16 to deal with mode=4
c	     problems.
c     INTEGER MAXWIN
c     PARAMETER ( MAXWIN = 16 )
c
c=======================================================================
c
c <<< ../../src/inc/caldefs.h
c >>> ../../src/inc/calfit.h
c=======================================================================
c	[calfit.h]
c*calfit_h -- calibration include file
c&pjt
c:calibration, include
c+
c  lsq()        matrix used for inversion
c  lsqb()       vector, used as right hand side AND solution
c  xsums()      temporary storage use to fill lsq()
c  ysums()      temporary storage use to fill lsq()
c
c
c  MAXLSQ -- the size of arrays and matrices in the least squares fit
c
      INTEGER MAXLSQ
      PARAMETER(MAXLSQ=(MAXANTHC*(MAXORDER+1)))
c
c  lsq, lsqb -- least squares matrix and rhs
c
      DOUBLE PRECISION lsq( MAXLSQ, MAXLSQ )
      DOUBLE PRECISION lsqb( MAXLSQ )
c
c  xsums, ysums -- sums-of-squares
c
      DOUBLE PRECISION xsums( 0 : 2 * MAXORDER )
      DOUBLE PRECISION ysums( 0 : MAXORDER )
c
      COMMON /lsq/ xsums, ysums, lsq, lsqb
c--
c=======================================================================
c
c <<< ../../src/inc/calfit.h
c
        DOUBLE PRECISION xpow
        INTEGER c, p
c
        DO p = 0, 2 * pmax
            xsums(p) = 0.0
        ENDDO
        DO p = 0, pmax
            ysums(p) = 0.0
        ENDDO
c
        DO c = 1, count
            xpow = 1.0
            DO p = 0, pmax
                ysums(p) = ysums(p) + xpow * y(c)
                xsums(p) = xsums(p) + xpow
                xpow = xpow * x(c)
            ENDDO
            DO p = pmax + 1, 2 * pmax
                xsums(p) = xsums(p) + xpow
                xpow = xpow * x(c)
            ENDDO
        ENDDO
c
        END
c*lsqfill -- add sums-of-squares to least squares matrix
c:Polynomials, Calibration, Least-Squares
c& pjt
c+
        SUBROUTINE lsqfill( count, x, y, pmax )
c
        INTEGER count, pmax
        REAL    x(*), y(*)
c  Inputs:
c	count -- the number of data points
c	x     -- independent variable
c	y     -- dependent variable
c	pmax  -- polynomial order of fit
c
c--
c >>> ../../src/inc/caldefs.h
c=======================================================================
c [caldefs.h]
c General include file that every calibration routine needs. It does not
c define (space for) data, but defines the constants that should be used
c in defining array-sizes.
c	18-nov-90 	added PI and TWOPI			PJT
c	 6-jul-91	V6.3 new MAXANTHC and MAXBASHC          pjt
c	26-sep-91       increased MAXUVPNT and MAXBREAK
c	 2-dec-91	V6.4 changed calbflux's dimensionality	PJT
c	19-apr-93	MAXSLOT from 20 to 36 for screwed mode-4  PJT
c			added MAXWIN from 8 (hardcoded) to 16
c	15-apr-94	MAXWIN is now in maxdim.h		PJT/mchw
c       19-dec-95       increase MAXANTHC from 6 to 9 !!!       pjt
c        9-Feb-99       increase MAXANTHC from 9 to 10 !       mchw
c       25-Apr-06       Increase MAXANTHC from 10 to 15 for CARMA ! mh
c=======================================================================
c >>> ../../src/inc/maxdim.h
c src/inc/cfg_maxdim.h.  Generated from maxdim.h.in by configure.
c TELESCOPE=carma
c=======================================================================
        CHARACTER*(*) MIRTEL
        PARAMETER(MIRTEL='carma')
        INTEGER   MAXBUF
        PARAMETER(MAXBUF=10000000)
c
        INTEGER   MAXDIM, MAXDIM2
        PARAMETER(MAXDIM=65536,MAXDIM2=8192)
c
        INTEGER   MAXANT,MAXANT2
        PARAMETER(MAXANT=64,MAXANT2=28)
c		maximum number of baselines
        INTEGER   MAXBASE
        PARAMETER(MAXBASE=1058)
        INTEGER   MAXBASE2
        PARAMETER(MAXBASE2=1058)
c
        INTEGER   MAXCHAN
        PARAMETER(MAXCHAN=8192)
c
        INTEGER   MAXWIN
        PARAMETER(MAXWIN=32)
c
        INTEGER   MAXWIDE
        PARAMETER(MAXWIDE=32)
c
        INTEGER   MAXFBIN
        PARAMETER(MAXFBIN=32)
c=======================================================================
c
c <<< ../../src/inc/maxdim.h
c=======================================================================
c >>> ../../src/inc/size.h
c=======================================================================
c	[size.h]
c
c  Include file used by calibration software
c
c  UL, RI, ULRI -- parameters which stand for LSB/USB and REAL/IMAG stuff
c
        integer UL, RI, ULRI
        parameter( UL = 2 )
        parameter( RI = 2 )
        parameter( ULRI = 4 )
c
c  SIZE -- lengths of reals/integers in number of bytes (IEEE/2s compl)
c
        integer SIZE
        parameter( SIZE = 4 )
c=======================================================================
c
c <<< ../../src/inc/size.h
c=======================================================================
c
c  SVERSION -- current version of cal format (consistency checks)
c              Version number is 10*MAJOR+MINOR
c              Datasets with a MAJOR difference, cannot be read
c              anymore, MINOR differences are normally compatible
c
      INTEGER SVERSION
      PARAMETER ( SVERSION = 64)
c
c MAXANTHC -- special Hat Creek MAXANT, to keep it small for us....
c MAXBASHC -- derived from MAXANTHC = max. number of baselines
c
c Now changed the number from Hat-Creek (10) to Cedar-Flat (15)
c although the name is the same.
c
      INTEGER MAXANTHC, MAXBASHC
      PARAMETER (MAXANTHC=15, MAXBASHC=((MAXANTHC*(MAXANTHC-1))/2))
c
c MAXUVPNT -- maximum number of UV points in time per track
c
      INTEGER   MAXUVPNT
      PARAMETER(MAXUVPNT=2000)
c
c  MAXSRC -- maximum number of sources in multi-source databases
c
      INTEGER MAXSRC
      PARAMETER( MAXSRC = 32 )
c
c  MAXBREAK -- maximum number of breakpoints on an interval
c
      INTEGER MAXBREAK
      PARAMETER( MAXBREAK = 10 )
c
c  MAXPOLY -- maximum number of polynomials on an interval
c             is normally one more than number of breakpoints, right?
c
      INTEGER MAXPOLY
      PARAMETER( MAXPOLY = MAXBREAK+1 )
c
c  MAXSLOT -- maximum number of polynomial slots
c             Allows for simultaneous presence of gcal & pcal format
c             The first 4 for gcal, last 16 for pcal
c             CALIB makes use of slot 5 and 6 for phase diff&mean
      INTEGER MAXSLOT
c      PARAMETER( MAXSLOT = 20 )
      PARAMETER( MAXSLOT = 36 )
c
c  MAXORDER -- highest allowed polynomial order
c             Don't set too high, inversions are already needed in
c             double precision this way.
      INTEGER MAXORDER
      PARAMETER( MAXORDER = 5 )
c
c  MAXWIN -- maximum number of windows - normally equals MAXSPECT = 8
c	     but temporarely increased to 16 to deal with mode=4
c	     problems.
c     INTEGER MAXWIN
c     PARAMETER ( MAXWIN = 16 )
c
c=======================================================================
c
c <<< ../../src/inc/caldefs.h
c >>> ../../src/inc/calfit.h
c=======================================================================
c	[calfit.h]
c*calfit_h -- calibration include file
c&pjt
c:calibration, include
c+
c  lsq()        matrix used for inversion
c  lsqb()       vector, used as right hand side AND solution
c  xsums()      temporary storage use to fill lsq()
c  ysums()      temporary storage use to fill lsq()
c
c
c  MAXLSQ -- the size of arrays and matrices in the least squares fit
c
      INTEGER MAXLSQ
      PARAMETER(MAXLSQ=(MAXANTHC*(MAXORDER+1)))
c
c  lsq, lsqb -- least squares matrix and rhs
c
      DOUBLE PRECISION lsq( MAXLSQ, MAXLSQ )
      DOUBLE PRECISION lsqb( MAXLSQ )
c
c  xsums, ysums -- sums-of-squares
c
      DOUBLE PRECISION xsums( 0 : 2 * MAXORDER )
      DOUBLE PRECISION ysums( 0 : MAXORDER )
c
      COMMON /lsq/ xsums, ysums, lsq, lsqb
c--
c=======================================================================
c
c <<< ../../src/inc/calfit.h
c
        INTEGER p1, p2
c
        CALL squares( count, X, Y, pmax )
c
        DO p1 = 0, pmax
            DO p2 = 0, pmax
                lsq(1+p1,1+p2) = 0.0
            ENDDO
        ENDDO
c
        DO p1 = 0, pmax
            lsqb(1+p1) = ysums(p1)
            DO p2 = 0, pmax
                lsq(1+p1,1+p2) = xsums(p1+p2)
            ENDDO
        ENDDO
c
        CALL solve( 1 + pmax )
c+debug
c Calling this would overwrite the DOUBLE with REAL solution -
c see comments below in LSQSAULT
c        CALL lsqsault(count, x, y, pmax )
c-debug
        END
c*solve -- solve a matrix for lsqfill
c:Polynomials, Calibration, Least-Squares
c& pjt
c+
        SUBROUTINE solve( nlsq )
c
        INTEGER nlsq
c
c  Inputs:
c	nlsq -- order of final least squares fit
c
c--
c >>> ../../src/inc/caldefs.h
c=======================================================================
c [caldefs.h]
c General include file that every calibration routine needs. It does not
c define (space for) data, but defines the constants that should be used
c in defining array-sizes.
c	18-nov-90 	added PI and TWOPI			PJT
c	 6-jul-91	V6.3 new MAXANTHC and MAXBASHC          pjt
c	26-sep-91       increased MAXUVPNT and MAXBREAK
c	 2-dec-91	V6.4 changed calbflux's dimensionality	PJT
c	19-apr-93	MAXSLOT from 20 to 36 for screwed mode-4  PJT
c			added MAXWIN from 8 (hardcoded) to 16
c	15-apr-94	MAXWIN is now in maxdim.h		PJT/mchw
c       19-dec-95       increase MAXANTHC from 6 to 9 !!!       pjt
c        9-Feb-99       increase MAXANTHC from 9 to 10 !       mchw
c       25-Apr-06       Increase MAXANTHC from 10 to 15 for CARMA ! mh
c=======================================================================
c >>> ../../src/inc/maxdim.h
c src/inc/cfg_maxdim.h.  Generated from maxdim.h.in by configure.
c TELESCOPE=carma
c=======================================================================
        CHARACTER*(*) MIRTEL
        PARAMETER(MIRTEL='carma')
        INTEGER   MAXBUF
        PARAMETER(MAXBUF=10000000)
c
        INTEGER   MAXDIM, MAXDIM2
        PARAMETER(MAXDIM=65536,MAXDIM2=8192)
c
        INTEGER   MAXANT,MAXANT2
        PARAMETER(MAXANT=64,MAXANT2=28)
c		maximum number of baselines
        INTEGER   MAXBASE
        PARAMETER(MAXBASE=1058)
        INTEGER   MAXBASE2
        PARAMETER(MAXBASE2=1058)
c
        INTEGER   MAXCHAN
        PARAMETER(MAXCHAN=8192)
c
        INTEGER   MAXWIN
        PARAMETER(MAXWIN=32)
c
        INTEGER   MAXWIDE
        PARAMETER(MAXWIDE=32)
c
        INTEGER   MAXFBIN
        PARAMETER(MAXFBIN=32)
c=======================================================================
c
c <<< ../../src/inc/maxdim.h
c=======================================================================
c >>> ../../src/inc/size.h
c=======================================================================
c	[size.h]
c
c  Include file used by calibration software
c
c  UL, RI, ULRI -- parameters which stand for LSB/USB and REAL/IMAG stuff
c
        integer UL, RI, ULRI
        parameter( UL = 2 )
        parameter( RI = 2 )
        parameter( ULRI = 4 )
c
c  SIZE -- lengths of reals/integers in number of bytes (IEEE/2s compl)
c
        integer SIZE
        parameter( SIZE = 4 )
c=======================================================================
c
c <<< ../../src/inc/size.h
c=======================================================================
c
c  SVERSION -- current version of cal format (consistency checks)
c              Version number is 10*MAJOR+MINOR
c              Datasets with a MAJOR difference, cannot be read
c              anymore, MINOR differences are normally compatible
c
      INTEGER SVERSION
      PARAMETER ( SVERSION = 64)
c
c MAXANTHC -- special Hat Creek MAXANT, to keep it small for us....
c MAXBASHC -- derived from MAXANTHC = max. number of baselines
c
c Now changed the number from Hat-Creek (10) to Cedar-Flat (15)
c although the name is the same.
c
      INTEGER MAXANTHC, MAXBASHC
      PARAMETER (MAXANTHC=15, MAXBASHC=((MAXANTHC*(MAXANTHC-1))/2))
c
c MAXUVPNT -- maximum number of UV points in time per track
c
      INTEGER   MAXUVPNT
      PARAMETER(MAXUVPNT=2000)
c
c  MAXSRC -- maximum number of sources in multi-source databases
c
      INTEGER MAXSRC
      PARAMETER( MAXSRC = 32 )
c
c  MAXBREAK -- maximum number of breakpoints on an interval
c
      INTEGER MAXBREAK
      PARAMETER( MAXBREAK = 10 )
c
c  MAXPOLY -- maximum number of polynomials on an interval
c             is normally one more than number of breakpoints, right?
c
      INTEGER MAXPOLY
      PARAMETER( MAXPOLY = MAXBREAK+1 )
c
c  MAXSLOT -- maximum number of polynomial slots
c             Allows for simultaneous presence of gcal & pcal format
c             The first 4 for gcal, last 16 for pcal
c             CALIB makes use of slot 5 and 6 for phase diff&mean
      INTEGER MAXSLOT
c      PARAMETER( MAXSLOT = 20 )
      PARAMETER( MAXSLOT = 36 )
c
c  MAXORDER -- highest allowed polynomial order
c             Don't set too high, inversions are already needed in
c             double precision this way.
      INTEGER MAXORDER
      PARAMETER( MAXORDER = 5 )
c
c  MAXWIN -- maximum number of windows - normally equals MAXSPECT = 8
c	     but temporarely increased to 16 to deal with mode=4
c	     problems.
c     INTEGER MAXWIN
c     PARAMETER ( MAXWIN = 16 )
c
c=======================================================================
c
c <<< ../../src/inc/caldefs.h
c >>> ../../src/inc/calfit.h
c=======================================================================
c	[calfit.h]
c*calfit_h -- calibration include file
c&pjt
c:calibration, include
c+
c  lsq()        matrix used for inversion
c  lsqb()       vector, used as right hand side AND solution
c  xsums()      temporary storage use to fill lsq()
c  ysums()      temporary storage use to fill lsq()
c
c
c  MAXLSQ -- the size of arrays and matrices in the least squares fit
c
      INTEGER MAXLSQ
      PARAMETER(MAXLSQ=(MAXANTHC*(MAXORDER+1)))
c
c  lsq, lsqb -- least squares matrix and rhs
c
      DOUBLE PRECISION lsq( MAXLSQ, MAXLSQ )
      DOUBLE PRECISION lsqb( MAXLSQ )
c
c  xsums, ysums -- sums-of-squares
c
      DOUBLE PRECISION xsums( 0 : 2 * MAXORDER )
      DOUBLE PRECISION ysums( 0 : MAXORDER )
c
      COMMON /lsq/ xsums, ysums, lsq, lsqb
c--
c=======================================================================
c
c <<< ../../src/inc/calfit.h
c
        INTEGER ipvt( MAXLSQ ), info
c+DEBUG
c	INTEGER i,j
c	write(*,*) 'Solve'
c	DO i=1,nlsq
c		write(*,*) (lsq(i,j), j=1,nlsq), ' * X = ',lsqb(i)
c	ENDDO
c-debug
        CALL dgefa( lsq, MAXLSQ, nlsq, ipvt, info )
        IF( info .NE. 0 ) CALL bug('f',
     *      'POLYFIT: singular least squares matrix')
        CALL dgesl( lsq, MAXLSQ, nlsq, ipvt, lsqb, 0 )
c+debug
c	write(*,*) 'Solution'
c	DO i=1,nlsq
c		write(*,*) 'SOL=',lsqb(i)
c	ENDDO
c-debug
c
        RETURN
        END
c***********************************************************************
c Does same as lsqfill, but using Sault's Llsqu* routines in single prec.
c I was puzzled by the fact that the DOUBLE PREC solution of a 2nd order
c polynomial gave not quite an exact solution, i.e. CALFIT claimed there
c was still a small (of order 0.01 radians) rms error. The REAL soltution
c via LSQSAULT was even worse... I'll think about it later... something
c is clearly not well here...
c
        SUBROUTINE lsqsault( count, x, y, pmax )
c
        INTEGER count, pmax
        REAL    x(*), y(*)
c
c >>> ../../src/inc/caldefs.h
c=======================================================================
c [caldefs.h]
c General include file that every calibration routine needs. It does not
c define (space for) data, but defines the constants that should be used
c in defining array-sizes.
c	18-nov-90 	added PI and TWOPI			PJT
c	 6-jul-91	V6.3 new MAXANTHC and MAXBASHC          pjt
c	26-sep-91       increased MAXUVPNT and MAXBREAK
c	 2-dec-91	V6.4 changed calbflux's dimensionality	PJT
c	19-apr-93	MAXSLOT from 20 to 36 for screwed mode-4  PJT
c			added MAXWIN from 8 (hardcoded) to 16
c	15-apr-94	MAXWIN is now in maxdim.h		PJT/mchw
c       19-dec-95       increase MAXANTHC from 6 to 9 !!!       pjt
c        9-Feb-99       increase MAXANTHC from 9 to 10 !       mchw
c       25-Apr-06       Increase MAXANTHC from 10 to 15 for CARMA ! mh
c=======================================================================
c >>> ../../src/inc/maxdim.h
c src/inc/cfg_maxdim.h.  Generated from maxdim.h.in by configure.
c TELESCOPE=carma
c=======================================================================
        CHARACTER*(*) MIRTEL
        PARAMETER(MIRTEL='carma')
        INTEGER   MAXBUF
        PARAMETER(MAXBUF=10000000)
c
        INTEGER   MAXDIM, MAXDIM2
        PARAMETER(MAXDIM=65536,MAXDIM2=8192)
c
        INTEGER   MAXANT,MAXANT2
        PARAMETER(MAXANT=64,MAXANT2=28)
c		maximum number of baselines
        INTEGER   MAXBASE
        PARAMETER(MAXBASE=1058)
        INTEGER   MAXBASE2
        PARAMETER(MAXBASE2=1058)
c
        INTEGER   MAXCHAN
        PARAMETER(MAXCHAN=8192)
c
        INTEGER   MAXWIN
        PARAMETER(MAXWIN=32)
c
        INTEGER   MAXWIDE
        PARAMETER(MAXWIDE=32)
c
        INTEGER   MAXFBIN
        PARAMETER(MAXFBIN=32)
c=======================================================================
c
c <<< ../../src/inc/maxdim.h
c=======================================================================
c >>> ../../src/inc/size.h
c=======================================================================
c	[size.h]
c
c  Include file used by calibration software
c
c  UL, RI, ULRI -- parameters which stand for LSB/USB and REAL/IMAG stuff
c
        integer UL, RI, ULRI
        parameter( UL = 2 )
        parameter( RI = 2 )
        parameter( ULRI = 4 )
c
c  SIZE -- lengths of reals/integers in number of bytes (IEEE/2s compl)
c
        integer SIZE
        parameter( SIZE = 4 )
c=======================================================================
c
c <<< ../../src/inc/size.h
c=======================================================================
c
c  SVERSION -- current version of cal format (consistency checks)
c              Version number is 10*MAJOR+MINOR
c              Datasets with a MAJOR difference, cannot be read
c              anymore, MINOR differences are normally compatible
c
      INTEGER SVERSION
      PARAMETER ( SVERSION = 64)
c
c MAXANTHC -- special Hat Creek MAXANT, to keep it small for us....
c MAXBASHC -- derived from MAXANTHC = max. number of baselines
c
c Now changed the number from Hat-Creek (10) to Cedar-Flat (15)
c although the name is the same.
c
      INTEGER MAXANTHC, MAXBASHC
      PARAMETER (MAXANTHC=15, MAXBASHC=((MAXANTHC*(MAXANTHC-1))/2))
c
c MAXUVPNT -- maximum number of UV points in time per track
c
      INTEGER   MAXUVPNT
      PARAMETER(MAXUVPNT=2000)
c
c  MAXSRC -- maximum number of sources in multi-source databases
c
      INTEGER MAXSRC
      PARAMETER( MAXSRC = 32 )
c
c  MAXBREAK -- maximum number of breakpoints on an interval
c
      INTEGER MAXBREAK
      PARAMETER( MAXBREAK = 10 )
c
c  MAXPOLY -- maximum number of polynomials on an interval
c             is normally one more than number of breakpoints, right?
c
      INTEGER MAXPOLY
      PARAMETER( MAXPOLY = MAXBREAK+1 )
c
c  MAXSLOT -- maximum number of polynomial slots
c             Allows for simultaneous presence of gcal & pcal format
c             The first 4 for gcal, last 16 for pcal
c             CALIB makes use of slot 5 and 6 for phase diff&mean
      INTEGER MAXSLOT
c      PARAMETER( MAXSLOT = 20 )
      PARAMETER( MAXSLOT = 36 )
c
c  MAXORDER -- highest allowed polynomial order
c             Don't set too high, inversions are already needed in
c             double precision this way.
      INTEGER MAXORDER
      PARAMETER( MAXORDER = 5 )
c
c  MAXWIN -- maximum number of windows - normally equals MAXSPECT = 8
c	     but temporarely increased to 16 to deal with mode=4
c	     problems.
c     INTEGER MAXWIN
c     PARAMETER ( MAXWIN = 16 )
c
c=======================================================================
c
c <<< ../../src/inc/caldefs.h
c >>> ../../src/inc/calfit.h
c=======================================================================
c	[calfit.h]
c*calfit_h -- calibration include file
c&pjt
c:calibration, include
c+
c  lsq()        matrix used for inversion
c  lsqb()       vector, used as right hand side AND solution
c  xsums()      temporary storage use to fill lsq()
c  ysums()      temporary storage use to fill lsq()
c
c
c  MAXLSQ -- the size of arrays and matrices in the least squares fit
c
      INTEGER MAXLSQ
      PARAMETER(MAXLSQ=(MAXANTHC*(MAXORDER+1)))
c
c  lsq, lsqb -- least squares matrix and rhs
c
      DOUBLE PRECISION lsq( MAXLSQ, MAXLSQ )
      DOUBLE PRECISION lsqb( MAXLSQ )
c
c  xsums, ysums -- sums-of-squares
c
      DOUBLE PRECISION xsums( 0 : 2 * MAXORDER )
      DOUBLE PRECISION ysums( 0 : MAXORDER )
c
      COMMON /lsq/ xsums, ysums, lsq, lsqb
c--
c=======================================================================
c
c <<< ../../src/inc/calfit.h
c
        INTEGER MAXS
        PARAMETER (MAXS=3)
        REAL bigb(MAXS,MAXS),bigf(1),bigx(MAXS),biga(MAXS,1), tmp
        INTEGER n, m, i, j, pivot(MAXS), ifail
c
        n=pmax+1
        m=1
        IF(n.GT.MAXS) CALL bug('f','LSQSAULT: order too big')
        CALL LlsquIni(bigx,bigb,n)
        DO i=1,count
            bigf(1) = y(i)
            tmp = 1.0
            DO j=1, n
                biga(j,1) = tmp
                tmp = tmp*x(i)
            ENDDO
            CALL LlsquAcc(bigf, biga, bigx, bigb, m, n)
        ENDDO
c+debug
c	write(*,*) 'Sault'
c	DO i=1,n
c		write(*,*) (bigb(i,j), j=1,n), ' * X = ',bigx(i)
c	ENDDO
c
        CALL LlsquSol(bigx, bigb, n, ifail, pivot)
c
c+debug
c	DO i=1,n
c		write(*,*) 'sol=',bigx(i)
c	ENDDO
c
c and copy the solution into the common block data in calfit.h
        DO i=1,n
            lsqb(i) = bigx(i)
        ENDDO
c
        END
