
/* System dependent initialisation. */

#define FORTRAN_CVT_INT 0
#define FORTRAN_CVT_LOG 0
typedef int fort_integer;
typedef int fort_logical;
typedef long fort_ptrdiff;
typedef float fort_real;
typedef double fort_double;
char *zterm(char *string,int length);
void pad(char *string,int length);
int *iface_iarr(int n);
void iface_f2c_icvt(fort_integer *in,int *out,int n);
void iface_c2f_icvt(int *in,fort_integer *out,int n);
int *iface_larr(int n);
void iface_f2c_lcvt(fort_logical *in,int *out,int n);
void iface_c2f_lcvt(int *in,fort_logical *out,int n);
/************************************************************************/
/*   10-dec-2004   pjt      from sma.f2c for SMA integration            */
/*   14-jan-2005   jhz/pjt  for the new merged sma_mirRead.c            */
/*   02-jun-2005   jhz      add arguments rfreq1 and vsour1 to          */
/*                          rspokeinisma                                */
/*   03-feb-2006   jhz      added dsb1 to  rspokeinisma_c               */
/*   18-may-2006   jhz      added nohighspr1 to rspokeinisma_c          */
/*   10-jan-2007   jhz      added evec to rspokeinisma_c                */
/************************************************************************/
#if defined(HAVE_CONFIG_H) && HAVE_CONFIG_H
#include "config.h"
#endif

#include <string.h>
#include "miriad.h"
/*#include "sysdep.h"*/
#include "io.h"

/************************************************************************/

void jpllinerd_(fmx,fmn,strl,nmol,moltag,mxnline,freq,intensity,uqst,lqst,mtag)
fort_real *fmx;
fort_real *fmn;
fort_real *strl;
fort_integer *nmol;
fort_integer *moltag;
fort_integer *mxnline;
fort_real *freq;
fort_real *intensity;
fort_integer *uqst;
fort_integer *lqst;
fort_integer *mtag;
{
    jpllinerd_c(*fmx, *fmn, *strl, *nmol,moltag, 
    (char *)mxnline,
    freq, intensity, 
    uqst, lqst, mtag);
}

void molselect_(jplpath,pathlen,mtag,nmline,mname,jplpath_len,mname_len)
char *jplpath;
int jplpath_len;
fort_integer *pathlen;
fort_integer *mtag;
fort_integer *nmline;
char *mname;
int mname_len;
{     molselect_c(jplpath, *pathlen, mtag, 
           (char *)nmline, mname, mname_len);
}

void rsmirread_(datapath,jstat,datapath_len)
char *datapath;
int datapath_len;
fort_integer *jstat;
{
  rsmirread_c(zterm(datapath,datapath_len), (char *)jstat);
}

void rsmiriadwrite_(datapath,jstat,datapath_len)
char *datapath;
int datapath_len;
fort_integer *jstat;
{
  rsmiriadwrite_c(zterm(datapath,datapath_len), (char *)jstat);
}

void rssmaflush_(scanskip,scanproc,sb,rxif,dosporder,doeng,doflppha)
fort_integer *scanskip;
fort_integer *scanproc;
fort_integer *sb;
fort_integer *rxif;
fort_integer *dosporder;
fort_integer *doeng;
fort_integer *doflppha;
{
   rssmaflush_c(*scanskip,
              *scanproc, *sb, *rxif, *dosporder,
              *doeng,*doflppha);
}

void rspokeinisma_(tbd,tno1,dosam1,doxyp1,doop1,dohann1,birdie1,dowt1,dopmps1,dobary1,doif1,hires1,nopol1,circular1,linear1,oldpol1,lat1,long1,evec1,rsnchan1,refant1,dolsr1,rfreq1,vsour1,antpos1,readant1,noskip1,spskip1,dsb1,mcconfig1,nohighspr1,dodebug1)
fort_integer *tbd;
fort_integer *tno1;
fort_logical *dosam1;
fort_logical *doxyp1;
fort_logical *doop1;
fort_logical *dohann1;
fort_logical *birdie1;
fort_logical *dowt1;
fort_logical *dopmps1;
fort_logical *dobary1;
fort_logical *doif1;
fort_logical *hires1;
fort_logical *nopol1;
fort_logical *circular1;
fort_logical *linear1;
fort_logical *oldpol1;
fort_double *lat1;
fort_double *long1;
fort_double *evec1;
fort_integer *rsnchan1;
fort_integer *refant1;
fort_logical *dolsr1;
fort_double *rfreq1;
fort_real *vsour1;
fort_double *antpos1;
fort_integer *readant1;
fort_logical *noskip1;
fort_integer *spskip1;
fort_logical *dsb1;
fort_logical *mcconfig1;
fort_logical *nohighspr1;
fort_logical *dodebug1;
        {
      rspokeinisma_c((char *)tbd, *tno1,
          dosam1, doxyp1, doop1, dohann1,
          birdie1, dowt1, dopmps1, dobary1,
          doif1, hires1, nopol1, circular1,
          linear1, oldpol1, *lat1, *long1, 
          *evec1, *rsnchan1,
          *refant1, dolsr1, *rfreq1, vsour1,
	  antpos1, *readant1, noskip1, spskip1,
	  dsb1, mcconfig1, nohighspr1,
          dodebug1);
        }
void rspokeflshsma_(tbd)
fort_integer *tbd;
{
    rspokeflshsma_c((char *)tbd);
}

