
/* System dependent initialisation. */

#define FORTRAN_CVT_INT 0
#define FORTRAN_CVT_LOG 0
typedef int fort_integer;
typedef int fort_logical;
typedef long fort_ptrdiff;
typedef float fort_real;
typedef double fort_double;
char *zterm(char *string,int length);
void pad(char *string,int length);
int *iface_iarr(int n);
void iface_f2c_icvt(fort_integer *in,int *out,int n);
void iface_c2f_icvt(int *in,fort_integer *out,int n);
int *iface_larr(int n);
void iface_f2c_lcvt(fort_logical *in,int *out,int n);
void iface_c2f_lcvt(int *in,fort_logical *out,int n);
/******************************************************************************/
/*                                                                            */
/* Conversion for the tabio routine from FORTRAN to C                         */
/*                                                                            */
/*  History:                                                                  */
/*    pjt   9aug07 Original version.                                          */
/******************************************************************************/

#if defined(HAVE_CONFIG_H) && HAVE_CONFIG_H
#include "config.h"
#endif

#include "miriad.h"

/************************************************************************/
void tabopen_(tno,name,status,ncol,nrow,name_len,status_len)
fort_integer *tno;
char *name;
int name_len;
char *status;
int status_len;
fort_integer *ncol;
fort_integer *nrow;
{
  tabopen_c( tno, zterm(name,name_len), zterm(status,status_len), ncol, nrow );
}
/************************************************************************/
void tabclose_(tno)
fort_integer *tno;
{
  tabclose_c(*tno);
}
/************************************************************************/
void tabsetr_(tno,row)
fort_integer *tno;
fort_integer *row;
{
  tabsetr_c(*tno, *row);
}
/************************************************************************/
void tabfmtc_(tno,col,fmt,fmt_len)
fort_integer *tno;
fort_integer *col;
char *fmt;
int fmt_len;
{
  tabfmtc_c(*tno, *col, zterm(fmt,fmt_len));
}
/************************************************************************/
void tabcmt_(tno,comment,comment_len)
fort_integer *tno;
char *comment;
int comment_len;
{
  tabcmt_c(*tno,zterm(comment,comment_len));
}
/************************************************************************/
void tabwcr_(tno,col,value)
fort_integer *tno;
fort_integer *col;
fort_real *value;
{
  tabwcr_c(*tno,*col,*value);
}
/************************************************************************/
void tabwcd_(tno,col,value)
fort_integer *tno;
fort_integer *col;
fort_double *value;
{
  tabwcd_c(*tno,*col,*value);
}
/************************************************************************/
void tabwci_(tno,col,value)
fort_integer *tno;
fort_integer *col;
fort_integer *value;
{
  tabwci_c(*tno,*col,*value);
}
/************************************************************************/
void tabwca_(tno,col,value,value_len)
fort_integer *tno;
fort_integer *col;
char *value;
int value_len;
{
  tabwca_c(*tno,*col,zterm(value,value_len));
}


void tabgetr_(tno,row,data)
fort_integer *tno;
fort_integer *row;
fort_real *data;
{
  tabgetr_c(*tno, *row, data);
}

void tabgetd_(tno,row,data)
fort_integer *tno;
fort_integer *row;
fort_double *data;
{
  tabgetd_c(*tno, *row, data);
}

void tabgeta_(tno,row,data,data_len)
fort_integer *tno;
fort_integer *row;
char *data;
int data_len;
{
  tabgeta_c(*tno, *row, zterm(data,data_len));
}
