
/* System dependent initialisation. */

#define FORTRAN_CVT_INT 0
#define FORTRAN_CVT_LOG 0
typedef int fort_integer;
typedef int fort_logical;
typedef long fort_ptrdiff;
typedef float fort_real;
typedef double fort_double;
char *zterm(char *string,int length);
void pad(char *string,int length);
int *iface_iarr(int n);
void iface_f2c_icvt(fort_integer *in,int *out,int n);
void iface_c2f_icvt(int *in,fort_integer *out,int n);
int *iface_larr(int n);
void iface_f2c_lcvt(fort_logical *in,int *out,int n);
void iface_c2f_lcvt(int *in,fort_logical *out,int n);
/************************************************************************/
/*									*/
/*	This converts from a FORTRAN calling sequence into a C.		*/
/*									*/
/*  History:								*/
/*    rjs  Dark ages Original version.					*/
/*    rjs  23aug89   Change to calling sequence of hdprobe.		*/
/*    rjs   9oct89   Deleted bug,bugno,pack16,unpack16,delay from this	*/
/*		     file. Only file i/o in this file now.		*/
/*    rjs  18oct89   uvselect added.                                    */
/*    rjs  30oct89   PAD call in hisread fixed                          */
/*    rjs   1nov89   Fixed bug that had crept in during multiflow port.	*/
/*    rjs  15nov89   Added dexpand.					*/
/*    rjs  23apr90   Changed order of #include "io.h" and fortran.h,	*/
/*		     for UNICOS.					*/
/*    rjs  27apr90   Added hdelete.					*/
/*    rjs  17oct90   Fixed bug in hwritea.				*/
/*    rjs  22feb91   Added uvmark.					*/
/*    rjs  27mar91   Added uvwflgwr.					*/
/*    rjs  26mar92   Added uvsela.					*/
/*    rjs  24aug92   Deleted uvmark, added				*/
/*		     uvvarini,uvvarset,uvvarcpy,uvvarupd		*/
/*    rjs  21dec92   Rewritten using intf2c syntax.			*/
/*    rjs   3mar93   Add uvflush,hflush.				*/
/*    rjs  26aug93   Add hrm and habort.				*/
/*    rjs  30aug93   Add hseek and htell.				*/
/*    rjs   5jan94   Added hmode,hexists.				*/
/*    rjs   5nov94   Correct declaration of hexists, and get rid of	*/
/*		     casting int to char*.				*/
/*    rjs  27feb96   Added xyflush.					*/
/*    rjs  19mar97   Handle logical translation better. Tidying.	*/
/*    pjt   6sep06   read integers via rdhdi                            */
/*    rjs  01apr09   Add scrRecSz routine.				*/
/*    pjt  11may12   scrread/write now using ptrdiff                    */
/************************************************************************/
#if defined(HAVE_CONFIG_H) && HAVE_CONFIG_H
#include "config.h"
#endif

#include <string.h>
#include <sys/types.h>
#include <unistd.h>
#include "miriad.h"
#include "sysdep.h"


/************************************************************************/
fort_integer dexpand_(template,output,template_len,output_len)
char *template;
int template_len;
char *output;
int output_len;
{
  int dexpand_c();
  return(dexpand_c(zterm(template,template_len),output,output_len));
}
/************************************************************************/
void scropen_(handle)
fort_integer *handle;
{
  scropen_c(handle);
}
/************************************************************************/
void scrclose_(handle)
fort_integer *handle;
{
  scrclose_c(*handle);
}
/************************************************************************/
void scrrecsz_(handle,recsize)
fort_integer *handle;
fort_integer *recsize;
{
  scrrecsz_c(*handle,*recsize);
}
/************************************************************************/
void scrread_(handle,buffer,offset,length)
fort_integer *handle;
fort_real *buffer;
fort_ptrdiff *offset;
fort_integer *length;
{
  scrread_c(*handle,buffer,*offset,*length);
}
/************************************************************************/
void scrwrite_(handle,buffer,offset,length)
fort_integer *handle;
fort_real *buffer;
fort_ptrdiff *offset;
fort_integer *length;
{
  scrwrite_c(*handle,buffer,*offset,*length);
}
/************************************************************************/
void uvopen_(tno,name,status,name_len,status_len)
fort_integer *tno;
char *name;
int name_len;
char *status;
int status_len;
{
  uvopen_c(tno,zterm(name,name_len),zterm(status,status_len));
}
/************************************************************************/
void uvtrack_(tno,name,switches,name_len,switches_len)
fort_integer *tno;
char *name;
int name_len;
char *switches;
int switches_len;
{
  uvtrack_c(*tno,zterm(name,name_len),zterm(switches,switches_len));
}
/************************************************************************/
void uvcopyvr_(tin,tout)
fort_integer *tin;
fort_integer *tout;
{
  uvcopyvr_c(*tin,*tout);
}
/************************************************************************/
void uvvarini_(tno,handle)
fort_integer *tno;
fort_integer *handle;
{
  uvvarini_c(*tno,handle);
}
/************************************************************************/
void uvvarset_(handle,name,name_len)
fort_integer *handle;
char *name;
int name_len;
{
  uvvarset_c(*handle,zterm(name,name_len));
}
/************************************************************************/
void uvvarcpy_(handle,tout)
fort_integer *handle;
fort_integer *tout;
{
  uvvarcpy_c(*handle,*tout);
}
/************************************************************************/
fort_integer uvvarupd_(handle)
fort_integer *handle;
{
  return(uvvarupd_c(*handle));
}
/************************************************************************/
void uvflush_(tno)
fort_integer *tno;
{
  uvflush_c(*tno);
}
/************************************************************************/
void uvclose_(tno)
fort_integer *tno;
{
  uvclose_c(*tno);
}
/************************************************************************/
fort_integer uvupdate_(tno)
fort_integer *tno;
{
  return(uvupdate_c(*tno));
}
/************************************************************************/
void uvnext_(tno)
fort_integer *tno;
{
  uvnext_c(*tno);
}
/************************************************************************/
fort_integer uvscan_(tno,var,var_len)
fort_integer *tno;
char *var;
int var_len;
{
  return(uvscan_c(*tno,zterm(var,var_len)));
}
/************************************************************************/
void uvrewind_(tno)
fort_integer *tno;
{
  uvrewind_c(*tno);
}
/************************************************************************/
void uvread_(tno,preamble,data,flags,n,nread)
fort_integer *tno;
fort_double *preamble;
fort_real *data;
fort_logical *flags;
fort_integer *n;
fort_integer *nread;
{
  uvread_c(*tno,preamble,data,flags,*n,nread);
}
/************************************************************************/
void uvwread_(tno,data,flags,n,nread)
fort_integer *tno;
fort_real *data;
fort_logical *flags;
fort_integer *n;
fort_integer *nread;
{
  uvwread_c(*tno,data,flags,*n,nread);
}
/************************************************************************/
void uvflgwr_(tno,flags)
fort_integer *tno;
fort_logical *flags;
{
  uvflgwr_c(*tno,flags);
}
/************************************************************************/
void uvwflgwr_(tno,flags)
fort_integer *tno;
fort_logical *flags;
{
  uvwflgwr_c(*tno,flags);
}
/************************************************************************/
void uvset_(tno,object,type,n,p1,p2,p3,object_len,type_len)
fort_integer *tno;
char *object;
int object_len;
char *type;
int type_len;
fort_integer *n;
fort_real *p1;
fort_real *p2;
fort_real *p3;
{
  uvset_c(*tno,zterm(object,object_len),zterm(type,type_len),*n,
		(double)*p1,(double)*p2,(double)*p3);
}
/************************************************************************/
void uvselect_(tno,object,p1,p2,datasel,object_len)
fort_integer *tno;
char *object;
int object_len;
fort_double *p1;
fort_double *p2;
fort_logical *datasel;
{
  int flag;
  flag = FORT_LOGICAL(*datasel);
  uvselect_c(*tno,zterm(object,object_len),*p1,*p2,flag);
}
/************************************************************************/
void uvsela_(tno,object,string,datasel,object_len,string_len)
fort_integer *tno;
char *object;
int object_len;
char *string;
int string_len;
fort_logical *datasel;
{
  int flag;
  flag = FORT_LOGICAL(*datasel);
  uvsela_c(*tno,zterm(object,object_len),zterm(string,string_len),flag);
}
/************************************************************************/
void uvinfo_(tno,object,data,object_len)
fort_integer *tno;
char *object;
int object_len;
fort_double *data;
{
  uvinfo_c(*tno,zterm(object,object_len),data);
}
/************************************************************************/
void uvwrite_(tno,preamble,data,flags,n)
fort_integer *tno;
fort_double *preamble;
fort_real *data;
fort_logical *flags;
fort_integer *n;
{
  uvwrite_c(*tno,preamble,data,flags,*n);
}
/************************************************************************/
void uvwwrite_(tno,data,flags,n)
fort_integer *tno;
fort_real *data;
fort_logical *flags;
fort_integer *n;
{
  uvwwrite_c(*tno,data,flags,*n);
}
/************************************************************************/
void uvprobvr_(tno,var,type,length,updated,var_len,type_len)
fort_integer *tno;
char *var;
int var_len;
char *type;
int type_len;
fort_integer *length;
fort_logical *updated;
{
  uvprobvr_c(*tno,zterm(var,var_len),type,length,updated);
}
/************************************************************************/
void uvrdvra_(tno,var,data,def,var_len,data_len,def_len)
fort_integer *tno;
char *var;
int var_len;
char *data;
int data_len;
char *def;
int def_len;
{
  uvrdvr_c(*tno,H_BYTE,zterm(var,var_len),data,zterm(def,def_len),data_len);
  pad(data,data_len);
}  
/************************************************************************/
void uvrdvri_(tno,var,data,def,var_len)
fort_integer *tno;
char *var;
int var_len;
fort_integer *data;
fort_integer *def;
{
  uvrdvr_c(*tno,H_INT,zterm(var,var_len),(char *)data,(char *)def,1);
}
/************************************************************************/
void uvrdvrr_(tno,var,data,def,var_len)
fort_integer *tno;
char *var;
int var_len;
fort_real *data;
fort_real *def;
{
  uvrdvr_c(*tno,H_REAL,zterm(var,var_len),(char *)data,(char *)def,1);
}
/************************************************************************/
void uvrdvrd_(tno,var,data,def,var_len)
fort_integer *tno;
char *var;
int var_len;
fort_double *data;
fort_double *def;
{
  uvrdvr_c(*tno,H_DBLE,zterm(var,var_len),(char *)data,(char *)def,1);
}
/************************************************************************/
void uvrdvrc_(tno,var,data,def,var_len)
fort_integer *tno;
char *var;
int var_len;
fort_real *data;
fort_real *def;
{
  uvrdvr_c(*tno,H_CMPLX,zterm(var,var_len),(char *)data,(char *)def,1);
}
/************************************************************************/
void uvgetvra_(tno,var,data,var_len,data_len)
fort_integer *tno;
char *var;
int var_len;
char *data;
int data_len;
{
  uvgetvr_c(*tno,H_BYTE,zterm(var,var_len),data,data_len);
  pad(data,data_len);
}  
/************************************************************************/
void uvgetvri_(tno,var,data,n,var_len)
fort_integer *tno;
char *var;
int var_len;
fort_integer *data;
fort_integer *n;
{
  uvgetvr_c(*tno,H_INT,zterm(var,var_len),(char *)data,*n);
}
/************************************************************************/
void uvgetvrj_(tno,var,data,n,var_len)
fort_integer *tno;
char *var;
int var_len;
fort_integer *data;
fort_integer *n;
{
  uvgetvr_c(*tno,H_INT2,zterm(var,var_len),(char *)data,*n);
}
/************************************************************************/
void uvgetvrr_(tno,var,data,n,var_len)
fort_integer *tno;
char *var;
int var_len;
fort_real *data;
fort_integer *n;
{
  uvgetvr_c(*tno,H_REAL,zterm(var,var_len),(char *)data,*n);
}
/************************************************************************/
void uvgetvrd_(tno,var,data,n,var_len)
fort_integer *tno;
char *var;
int var_len;
fort_double *data;
fort_integer *n;
{
  uvgetvr_c(*tno,H_DBLE,zterm(var,var_len),(char *)data,*n);
}
/************************************************************************/
void uvgetvrc_(tno,var,data,n,var_len)
fort_integer *tno;
char *var;
int var_len;
fort_real *data;
fort_integer *n;
{
  uvgetvr_c(*tno,H_CMPLX,zterm(var,var_len),(char *)data,*n);
}
/************************************************************************/
void uvputvri_(tno,var,data,n,var_len)
fort_integer *tno;
char *var;
int var_len;
fort_integer *data;
fort_integer *n;
{
  uvputvr_c(*tno,H_INT,zterm(var,var_len),(char *)data,*n);
}
/************************************************************************/
void uvputvrr_(tno,var,data,n,var_len)
fort_integer *tno;
char *var;
int var_len;
fort_real *data;
fort_integer *n;
{
  uvputvr_c(*tno,H_REAL,zterm(var,var_len),(char *)data,*n);
}
/************************************************************************/
void uvputvrd_(tno,var,data,n,var_len)
fort_integer *tno;
char *var;
int var_len;
fort_double *data;
fort_integer *n;
{
  uvputvr_c(*tno,H_DBLE,zterm(var,var_len),(char *)data,*n);
}
/************************************************************************/
void uvputvrc_(tno,var,data,n,var_len)
fort_integer *tno;
char *var;
int var_len;
fort_real *data;
fort_integer *n;
{
  uvputvr_c(*tno,H_CMPLX,zterm(var,var_len),(char *)data,*n);
}
/************************************************************************/
void uvputvra_(tno,var,data,var_len,data_len)
fort_integer *tno;
char *var;
int var_len;
char *data;
int data_len;
{
  char *s;
  s = zterm(data,data_len);
  uvputvr_c(*tno,H_BYTE,zterm(var,var_len),s,strlen(s));
}
/************************************************************************/
fort_logical uvchkshadow_(tno,diameter_meters)
fort_integer *tno;
fort_double *diameter_meters;
{
  return uvchkshadow_c (*tno, *diameter_meters) ?
     FORT_TRUE : FORT_FALSE;
}
/************************************************************************/
void hopen_(tno,name,status,iostat,name_len,status_len)
fort_integer *tno;
char *name;
int name_len;
char *status;
int status_len;
fort_integer *iostat;
{
  hopen_c(tno,zterm(name,name_len),zterm(status,status_len),iostat);
}
/************************************************************************/
void hclose_(tno)
fort_integer *tno;
{
  hclose_c(*tno);
}
/************************************************************************/
void hflush_(tno,iostat)
fort_integer *tno;
fort_integer *iostat;
{
  hflush_c(*tno,iostat);
}
/************************************************************************/
void habort_()
{
  habort_c();
}
/************************************************************************/
void hrm_(tno)
fort_integer *tno;
{
  hrm_c(*tno);
}
/************************************************************************/
void hdelete_(tno,name,iostat,name_len)
fort_integer *tno;
char *name;
int name_len;
fort_integer *iostat;
{
  hdelete_c(*tno,zterm(name,name_len),iostat);
}
/************************************************************************/
void haccess_(tno,item,name,status,iostat,name_len,status_len)
fort_integer *tno;
fort_integer *item;
char *name;
int name_len;
char *status;
int status_len;
fort_integer *iostat;
{
  haccess_c(*tno,item,zterm(name,name_len),zterm(status,status_len),iostat);
}
/************************************************************************/
void hmode_(tno,mode,mode_len)
fort_integer *tno;
char *mode;
int mode_len;
{
  hmode_c(*tno,mode);
  pad(mode,mode_len);
}
/************************************************************************/
fort_logical hexists_(tno,item,item_len)
fort_integer *tno;
char *item;
int item_len;
{
  return( hexists_c(*tno,zterm(item,item_len)) ? FORT_TRUE : FORT_FALSE);
}
/************************************************************************/
void hdaccess_(item,iostat)
fort_integer *item;
fort_integer *iostat;
{
  hdaccess_c(*item,iostat);
}
/************************************************************************/
fort_integer hsize_(item)
fort_integer *item;
{
  return(hsize_c(*item));
}
/************************************************************************/
fort_integer htell_(item)
fort_integer *item;
{
  return(htell_c(*item));
}
/************************************************************************/
void hseek_(item,offset)
fort_integer *item;
fort_integer *offset;
{
  hseek_c(*item,*offset);
}
/************************************************************************/
void hreada_(item,line,iostat,line_len)
fort_integer *item;
char *line;
int line_len;
fort_integer *iostat;
{
  hreada_c(*item,line,line_len,iostat);
  if(!*iostat)pad(line,line_len);
}
/************************************************************************/
void hwritea_(item,line,iostat,line_len)
fort_integer *item;
char *line;
int line_len;
fort_integer *iostat;
{
  char *s;

  s = zterm(line,line_len);
  hwritea_c(*item,s,strlen(s)+1,iostat);
}
/************************************************************************/
void hreadb_(item,buffer,offset,length,iostat,buffer_len)
fort_integer *item;
char *buffer;
int buffer_len;
fort_integer *offset;
fort_integer *length;
fort_integer *iostat;
{
  hreadb_c(*item,buffer,*offset,*length,iostat);
}
/************************************************************************/
void hwriteb_(item,buffer,offset,length,iostat,buffer_len)
fort_integer *item;
char *buffer;
int buffer_len;
fort_integer *offset;
fort_integer *length;
fort_integer *iostat;
{
  hwriteb_c(*item,buffer,*offset,*length,iostat);
}
/************************************************************************/
void hreadj_(item,buffer,offset,length,iostat)
fort_integer *item;
fort_integer *buffer;
fort_integer *offset;
fort_integer *length;
fort_integer *iostat;
{
  hreadj_c(*item,buffer,*offset,*length,iostat);
}
/************************************************************************/
void hwritej_(item,buffer,offset,length,iostat)
fort_integer *item;
fort_integer *buffer;
fort_integer *offset;
fort_integer *length;
fort_integer *iostat;
{
  hwritej_c(*item,buffer,*offset,*length,iostat);
}
/************************************************************************/
void hreadi_(item,buffer,offset,length,iostat)
fort_integer *item;
fort_integer *buffer;
fort_integer *offset;
fort_integer *length;
fort_integer *iostat;
{
  hreadi_c(*item,buffer,*offset,*length,iostat);
}
/************************************************************************/
void hwritei_(item,buffer,offset,length,iostat)
fort_integer *item;
fort_integer *buffer;
fort_integer *offset;
fort_integer *length;
fort_integer *iostat;
{
  hwritei_c(*item,buffer,*offset,*length,iostat);
}
/************************************************************************/
void hreadr_(item,buffer,offset,length,iostat)
fort_integer *item;
fort_real *buffer;
fort_integer *offset;
fort_integer *length;
fort_integer *iostat;
{
  hreadr_c(*item,buffer,*offset,*length,iostat);
}
/************************************************************************/
void hwriter_(item,buffer,offset,length,iostat)
fort_integer *item;
fort_real *buffer;
fort_integer *offset;
fort_integer *length;
fort_integer *iostat;
{
  hwriter_c(*item,buffer,*offset,*length,iostat);
}
/************************************************************************/
void hreadd_(item,buffer,offset,length,iostat)
fort_integer *item;
fort_double *buffer;
fort_integer *offset;
fort_integer *length;
fort_integer *iostat;
{
  hreadd_c(*item,buffer,*offset,*length,iostat);
}
/************************************************************************/
void hwrited_(item,buffer,offset,length,iostat)
fort_integer *item;
fort_double *buffer;
fort_integer *offset;
fort_integer *length;
fort_integer *iostat;
{
  hwrited_c(*item,buffer,*offset,*length,iostat);
}
/************************************************************************/
void hisopen_(tno,status,status_len)
fort_integer *tno;
char *status;
int status_len;
{
  hisopen_c(*tno,zterm(status,status_len));
}
/************************************************************************/
void hisread_(tno,line,eof,line_len)
fort_integer *tno;
char *line;
int line_len;
fort_logical *eof;
{
  hisread_c(*tno,line,line_len,eof);
  if(*eof != FORT_TRUE)pad(line,line_len);
}
/************************************************************************/
void hiswrite_(tno,line,line_len)
fort_integer *tno;
char *line;
int line_len;
{
  hiswrite_c(*tno,zterm(line,line_len));
}
/************************************************************************/
void hisclose_(tno)
fort_integer *tno;
{
  hisclose_c(*tno);
}
/************************************************************************/
void xyopen_(tno,name,status,naxis,axes,name_len,status_len)
fort_integer *tno;
char *name;
int name_len;
char *status;
int status_len;
fort_integer *naxis;
fort_integer *axes;
{
  xyopen_c(tno,zterm(name,name_len),zterm(status,status_len),*naxis,axes);
}
/************************************************************************/
void xyflush_(tno)
fort_integer *tno;
{
  xyflush_c(*tno);
}
/************************************************************************/
void xyclose_(tno)
fort_integer *tno;
{
  xyclose_c(*tno);
}
/************************************************************************/
void xyread_(tno,index,buffer)
fort_integer *tno;
fort_integer *index;
fort_real *buffer;
{
  xyread_c(*tno,*index,buffer);
}
/************************************************************************/
void xywrite_(tno,index,buffer)
fort_integer *tno;
fort_integer *index;
fort_real *buffer;
{
  xywrite_c(*tno,*index,buffer);
}
/************************************************************************/
void xymkrd_(tno,index,buffer,n,nread)
fort_integer *tno;
fort_integer *index;
fort_integer *buffer;
fort_integer *n;
fort_integer *nread;
{
  xymkrd_c(*tno,*index,buffer,*n,nread);
}
/************************************************************************/
void xymkwr_(tno,index,buffer,n)
fort_integer *tno;
fort_integer *index;
fort_integer *buffer;
fort_integer *n;
{
  xymkwr_c(*tno,*index,buffer,*n);
}
/************************************************************************/
void xyflgrd_(tno,index,buffer)
fort_integer *tno;
fort_integer *index;
fort_logical *buffer;
{
  xyflgrd_c(*tno,*index,buffer);
}
/************************************************************************/
void xyflgwr_(tno,index,buffer)
fort_integer *tno;
fort_integer *index;
fort_logical *buffer;
{
  xyflgwr_c(*tno,*index,buffer);
}
/************************************************************************/
void xysetpl_(tno,naxis,axes)
fort_integer *tno;
fort_integer *naxis;
fort_integer *axes;
{
  xysetpl_c(*tno,*naxis,axes);
}
/************************************************************************/
void hdprobe_(tno,keyword,descr,type,n,keyword_len,descr_len,type_len)
fort_integer *tno;
char *keyword;
int keyword_len;
char *descr;
int descr_len;
char *type;
int type_len;
fort_integer *n;
{
  hdprobe_c(*tno,zterm(keyword,keyword_len),descr,descr_len,type,n);
  pad(descr,descr_len);
  pad(type,type_len);
}
/************************************************************************/
void rdhdr_(tno,keyword,value,defval,keyword_len)
fort_integer *tno;
char *keyword;
int keyword_len;
fort_real *value;
fort_real *defval;
{
  double dvalue,ddefval;

  ddefval = *defval;
  rdhdd_c(*tno,zterm(keyword,keyword_len),&dvalue,ddefval);
  *(value) = dvalue;
}
/************************************************************************/
void rdhdi_(tno,keyword,value,defval,keyword_len)
fort_integer *tno;
char *keyword;
int keyword_len;
fort_integer *value;
fort_integer *defval;
{
  int ivalue,idefval;

  idefval = *defval;
  rdhdi_c(*tno,zterm(keyword,keyword_len),&ivalue,idefval);
  *(value) = ivalue;
}
/************************************************************************/
void rdhdd_(tno,keyword,value,defval,keyword_len)
fort_integer *tno;
char *keyword;
int keyword_len;
fort_double *value;
fort_double *defval;
{
  rdhdd_c(*tno,zterm(keyword,keyword_len),value,*defval);
}
/************************************************************************/
void rdhda_(tno,keyword,value,defval,keyword_len,value_len,defval_len)
fort_integer *tno;
char *keyword;
int keyword_len;
char *value;
int value_len;
char *defval;
int defval_len;
{
  rdhda_c(*tno,zterm(keyword,keyword_len),value,zterm(defval,defval_len),value_len);
  pad(value,value_len);
}
/************************************************************************/
void rdhdc_(tno,keyword,value,defval,keyword_len)
fort_integer *tno;
char *keyword;
int keyword_len;
fort_real *value;
fort_real *defval;
{
  rdhdc_c(*tno,zterm(keyword,keyword_len),value,defval);
}
/************************************************************************/
void wrhdr_(tno,keyword,value,keyword_len)
fort_integer *tno;
char *keyword;
int keyword_len;
fort_real *value;
{
  wrhdr_c(*tno,zterm(keyword,keyword_len),(double)*value);
}
/************************************************************************/
void wrhdd_(tno,keyword,value,keyword_len)
fort_integer *tno;
char *keyword;
int keyword_len;
fort_double *value;
{
  wrhdd_c(*tno,zterm(keyword,keyword_len),*value);
}
/************************************************************************/
void wrhdi_(tno,keyword,value,keyword_len)
fort_integer *tno;
char *keyword;
int keyword_len;
fort_integer *value;
{
  wrhdi_c(*tno,zterm(keyword,keyword_len),*value);
}
/************************************************************************/
void wrhdc_(tno,keyword,value,keyword_len)
fort_integer *tno;
char *keyword;
int keyword_len;
fort_real *value;
{
  wrhdc_c(*tno,zterm(keyword,keyword_len),value);
}
/************************************************************************/
void wrhda_(tno,keyword,value,keyword_len,value_len)
fort_integer *tno;
char *keyword;
int keyword_len;
char *value;
int value_len;
{
  wrhda_c(*tno,zterm(keyword,keyword_len),zterm(value,value_len));
}
/************************************************************************/
void hdcopy_(tIn,tOut,keyword,keyword_len)
fort_integer *tIn;
fort_integer *tOut;
char *keyword;
int keyword_len;
{
  hdcopy_c(*tIn,*tOut,zterm(keyword,keyword_len));
}
/************************************************************************/
fort_logical hdprsnt_(tno,keyword,keyword_len)
fort_integer *tno;
char *keyword;
int keyword_len;
{
  return(hdprsnt_c(*tno,zterm(keyword,keyword_len)));
}
/************************************************************************/
void getmaski_(mask,masks)
fort_integer *mask;
fort_integer *masks;
{
  getmaski_c(*mask, masks);
}
/************************************************************************/
void setmaski_(mask,masks)
fort_integer *mask;
fort_integer *masks;
{
  getmaski_c(mask, masks);
}
